/*3:*/
#line 57 "checkers.web"

#include <fork.h>
#include <stdlib.h>
#include <io.h>
#include "checkers.h"

/*:3*//*4:*/
#line 67 "checkers.web"

sync void show_array(sh int a[],sh int n)
{
sh p= groupsize();
sh int i;

ppar_array(i,n)farm pprintf("%d:%d\n",i,a[i]);
}

sync void scan_equal(sh int a[],sh int b[],sh int n)
{
sh int p= groupsize();
pr int i;

ppar_array(i,n)
if(a[i]!=b[i])
farm pprintf("Non-equal at %d, %d!=%d\n",i,a[i],b[i]);
}

sync void check_order(sh int a[],sh int n)
{
sh int p= groupsize();
pr int i;

ppar_array(i,n)
if(a[i]>a[i+1])
farm pprintf("Order violation at %d: %d>%d\n",i,a[i],a[i+1]);
}

/*:4*//*5:*/
#line 107 "checkers.web"

sync void check_list(sh LIST list[],sh int n)
{
sh int p= groupsize();
pr int i;

ppar_array(i,n){
if(list[i].succ!=NULL)
if(list[i].succ->pred!=list+i)
farm pprintf("SUCC of %d wrong\n",i);

if(list[i].pred!=NULL)
if(list[i].pred->succ!=list+i)
farm pprintf("PRED of %d wrong\n",i);
}
}

sync void check_rank(sh LIST list[],sh int n)
{
sh int p= groupsize();
pr int i;

ppar_array(i,n){
if(list[i].succ==NULL){
if(list[i].rank!=0)
farm pprintf("Tail rank %d of %d wrong\n",list[i].rank,i);
}else{
if(list[i].rank!=list[i].succ->rank+1)
farm pprintf("SUCC rank %d->%d of %d wrong\n",
list[i].rank,list[i].succ->rank,i);
}
if(list[i].pred!=NULL)
if(list[i].rank!=list[i].pred->rank-1)
farm pprintf("PRED rank %d<-%d of %d wrong\n",
list[i].pred->rank,list[i].rank,i);
}
}

sync void check_color(sh LIST list[],sh int c,sh int n)
{
sh int p= groupsize();
pr int i;

ppar_array(i,n){
if(list[i].color>=c)
farm pprintf("Invalid color %d for %d\n",list[i].color,i);
if(list[i].succ!=NULL)
if(list[i].color==list[i].succ->color)
farm pprintf("SUCC color %d->%d of %d wrong\n",
list[i].color,list[i].succ->color,i);
if(list[i].pred!=NULL)
if(list[i].color==list[i].pred->color)
farm pprintf("PRED color %d<-%d of %d wrong\n",
list[i].pred->color,list[i].color,i);
}
}

sync void check_last(sh LIST list[],sh int n)
{
sh int p= groupsize();
pr int i;

farm
ppar_array(i,n){
if(list[i].last->pred!=NULL)
pprintf("LAST of %d not head\n",i);
}
}


/*:5*//*7:*/
#line 180 "checkers.web"

sync void check_tree(sh TREE*t)
{
pr TREE_EDGE*e;

par_edges(e,t){
if(e!=e->rev->rev){
pprintf("Wrong reverse edge %d\n",e-t->edges);
}else{
if(e->head!=e->rev->tail)
printf("Head of %d wrong, %d!=%d\n",
e-t->edges,e->head-t->nodes,e->rev->tail-t->nodes);
if(e->tail!=e->rev->head)
printf("Tail of %d wrong, %d!=%d\n",
e-t->edges,e->tail-t->nodes,e->rev->head-t->nodes);
}
}
}

sync void check_rooted(sh TREE*t)
{
pr TREE_EDGE*e;
pr int legal;


farm legal= (t->root>=t->nodes&&t->root<t->endnode);
if(!legal)pprintf("Root illegal!\n");
else{
par_edges(e,t){
if(DOWN(e))
if(e->head->level!=e->tail->level+1)
pprintf("DOWN: Levels wrong %d!=%d for nodes %d and %d\n",
e->head->level,e->tail->level,e->head-t->nodes,e->tail-t->nodes);
if(UP(e))
if(e->head->level+1!=e->tail->level)
pprintf("UP: Levels wrong %d!=%d for nodes %d and %d\n",
e->head->level,e->tail->level,e->head-t->nodes,e->tail-t->nodes);
}
if(t->root->level!=0)
pprintf("Level %d of root %d wrong\n",t->root-t->nodes,t->root->level);
}
}

/*:7*//*8:*/
#line 226 "checkers.web"

sync void check_trav2(sh TREE*t1,sh TREE*t2)
{
sh int p= groupsize();
pr TREE_NODE*v1,*v2;

v2= t2->nodes+ME;
par_nodes(v1,t1){
if(v1->level!=v2->level)
pprintf("Level difference %d, %d!=%d\n",
v1-t1->nodes,v1->level,v2->level);
if(v1->pre!=v2->pre)
pprintf("Prenumber difference %d, %d!=%d\n",
v1-t1->nodes,v1->pre,v2->pre);
if(v1->post!=v2->post)
pprintf("Postnumber difference %d, %d!=%d\n",
v1-t1->nodes,v1->post,v2->post);
if(v1->desc!=v2->desc)
pprintf("Descendant difference %d, %d!=%d\n",
v1-t1->nodes,v1->desc,v2->desc);
v2+= p;
}
}

sync void check_height2(sh TREE*t1,sh TREE*t2)
{
sh int p= groupsize();
pr TREE_NODE*v1,*v2;

v2= t2->nodes+ME;
par_nodes(v1,t1){
if(v1->height!=v2->height)
pprintf("Height difference %d, %d!=%d\n",
v1-t1->nodes,v1->height,v2->height);
v2+= p;
}
}

/*:8*/
