/*41:*/
#line 2058 "dictionary.web"

#include <fork.h>
#include <io.h>
#include "pad.h"
#include "dictionary.h"

void main(void)
{

start{
sh DICT_NODE*dictionary;
sh DICT_NODE**item;
pr DICT_NODE*leaf;
sh int*searchkey;
sh int n;
sh int p= __STARTED_PROCS__;
pr int i;

n= 23;
searchkey= (int*)shalloc(n*sizeof(int));
item= (DICT_NODE**)shalloc(n*sizeof(DICT_NODE*));



for(i= ME;i<n;i+= p)item[i]= dictitem_new(2*i,NULL);



if(ME==0)pprintf("Building dictionary of %d items\n",n);
dictionary= dict_build(item,n);

if(!dict_empty(dictionary))
pprintf("%d elements in dictionary\n",dict_size(dictionary));

farm{
leaf= dict_search(dictionary,ME);
}
if(leaf==NULL)pprintf("Key %d not found\n",ME);
else pprintf("Found %d\n",dictitem_key(leaf));

farm{
leaf= dict_search(dictionary,2*n-ME);
}
if(leaf==NULL)pprintf("Key %d not found\n",2*n-ME);
else pprintf("Found %d\n",dictitem_key(leaf));



if(ME==0)pprintf("Inserting\n");
item[ME]= dictitem_new(2*ME+1,NULL);

dictionary= dict_insert(dictionary,item,p);
if(ME==0)pprintf("Searching\n");
for(i= ME;i<n;i+= p)searchkey[i]= i;
/*19:*/
#line 880 "dictionary.web"

farm{
for(i= ME;i<n;i+= p)item[i]= dict_search(dictionary,searchkey[i]);
}

/*:19*/
#line 2112 "dictionary.web"

for(i= ME;i<n;i+= p)
if(item[i]==NULL)pprintf("Key %d not found\n",searchkey[i]);
else pprintf("Found %d\n",dictitem_key(item[i]));



if(ME==0)pprintf("Inserting large items and chains\n");
item[ME]= dictitem_new(500+ME,NULL);
dictionary= dict_insert(dictionary,item,p);
i= dict_size(dictionary)-ME;
farm{
leaf= dict_retrieve(dictionary,i);
}
pprintf("The %d. item is %d\n",i,dictitem_key(leaf));
i= ME+1;
farm{
leaf= dict_retrieve(dictionary,i);
}
pprintf("The %d. item is %d\n",i,dictitem_key(leaf));

if(ME==0&&!dict_empty(dictionary))
pprintf("%d elements in dictionary. Inserting %d more\n",
dict_size(dictionary),n);

for(i= ME;i<n;i+= p)item[i]= dictitem_new(100+i,NULL);
dictionary= dict_insert(dictionary,item,n);

for(i= ME;i<n;i+= p)item[i]= dictitem_new(100+i,NULL);
dictionary= dict_insert(dictionary,item,n);

if(ME==0&&!dict_empty(dictionary))
pprintf("%d elements in dictionary\n",dict_size(dictionary));



farm{
item[ME]= dict_search(dictionary,ME+1);
}
dictionary= dict_delete(dictionary,item,p);
farm{
item[ME]= dict_search(dictionary,ME+1);
}
if(item[ME]!=NULL)
pprintf("Node %d not deleted!\n",dictitem_key(item[ME]));

if(ME==0&&!dict_empty(dictionary))
pprintf("%d elements in dictionary\n",dict_size(dictionary));
i= ME+1;
farm{
leaf= dict_retrieve(dictionary,i);
}
pprintf("The %d. item is %d\n",i,dictitem_key(leaf));

for(i= ME;i<n;i+= p)
searchkey[i]= 90+i;
/*19:*/
#line 880 "dictionary.web"

farm{
for(i= ME;i<n;i+= p)item[i]= dict_search(dictionary,searchkey[i]);
}

/*:19*/
#line 2168 "dictionary.web"

dictionary= dict_delete(dictionary,item,n);
if(ME==0&&!dict_empty(dictionary))
pprintf("%d elements in dictionary\n",dict_size(dictionary));
for(i= ME;i<n;i+= p)
if(item[i]!=NULL)
pprintf("Node %d not deleted!\n",dictitem_key(item[i]));



if(ME==0)pprintf("Removing the dictionary\n");
n= dict_flatten(dictionary,item);
for(i= ME;i<n;i+= p)pprintf("%d\n",dictitem_key(item[i]));
}
}

/*:41*/
