/*8:*/
#line 476 "dictionary.web"

#ifndef PADdictionary
#define PADdictionary
/*11:*/
#line 569 "dictionary.web"

#define MAX_CHILDREN 3

typedef struct dict_node{
int key;
int no_of_children;
int no_of_leaves;
int child_no;
int utility;
struct dict_node*children[MAX_CHILDREN];
struct dict_node*father;
}DICT_NODE;

/*:11*//*15:*/
#line 634 "dictionary.web"

#define dict_size(dictionary) (dictionary)->no_of_leaves
#define dict_empty(dictionary) ((dictionary)->no_of_leaves==0)

/*:15*/
#line 479 "dictionary.web"

/*7:*/
#line 450 "dictionary.web"

extern async DICT_NODE*dictitem_new(pr int key,pr void*content);
extern async int dictitem_key(pr DICT_NODE*item);
extern async void*dictitem_newcontent(pr DICT_NODE*item,pr void*content);


extern sync DICT_NODE*dict_build(sh DICT_NODE*item[],sh int n);
extern sync int dict_flatten(sh DICT_NODE*dictionary,sh DICT_NODE*item[]);
extern async DICT_NODE*dict_closest(pr DICT_NODE*dictionary,pr int key);
extern async DICT_NODE*dict_search(pr DICT_NODE*dictionary,pr int key);
extern async DICT_NODE*dict_retrieve(pr DICT_NODE*dictionary,pr int k);
extern async DICT_NODE*dict_find(pr DICT_NODE*dictionary,
pr DICT_NODE*searchitem,
async DICT_NODE*(*select)(pr DICT_NODE*,
pr DICT_NODE*));
extern async int dict_sum(pr DICT_NODE*item,
async int(*treesum)(pr DICT_NODE*));
extern sync DICT_NODE*dict_insert(sh DICT_NODE*dictionary,
sh DICT_NODE*item[],sh int n);
extern sync DICT_NODE*dict_delete(sh DICT_NODE*dictionary,
sh DICT_NODE*oldnodes[],sh int n);

/*:7*//*14:*/
#line 623 "dictionary.web"

#define dictitem_key(item) (item)->key
#define dictitem_content(item) (item)->children[0]
#define dictitem_free(item) free(item)

/*:14*/
#line 480 "dictionary.web"

#endif

/*:8*/
