/*91:*/
#line 3897 "ranking.web"

#include <stdlib.h>
#include <fork.h>
#include <io.h>

#include "pad.h"
#include "list.h"
#include "prefix.h"
#include "checkers.h" 

struct my_element{
struct my_element*next;
int contents;
};


async update(struct my_element*e1,struct my_element*e2)
{
e1->next= e2;
}

async struct my_element*next(struct my_element*e)
{
return e->next;
}


sync void showlist(sh LIST list[],sh int n)
{
pr int i;

par_array(i,n){
pprintf("Item %d: contents: %d next %d\n",i,
((struct my_element*)ELT(list,i))->contents,
list[i].succ!=NULL?
((struct my_element*)list[i].succ->element)->contents:-1);
}
}

sync void showends(sh LIST*heads[],sh LIST*tails[],sh int k)
{
pr int i;

par_array(i,k)
pprintf("Head contents: %d Tail contents: %d\n",
((struct my_element*)heads[i]->element)->contents,
((struct my_element*)tails[i]->element)->contents);


}

#define SHOW 10 

void main(void)
{
start{
sh int p;
sh int n;

sh LIST*slist,*tlist;
sh LIST**active;
pr struct my_element*element;
pr int i;
sh int n1,n2,n3;
sh int l;
pr int t;

sh LIST*lsts[4];
sh int szs[4];
sh LIST*heads[4];
sh LIST*tails[4];

sh int ss;

if(n<SHOW)ss= n;else ss= SHOW;

p= __STARTED_PROCS__;
n= 2999;

slist= (LIST*)shalloc(2*n*sizeof(LIST));
tlist= (LIST*)shalloc(2*n*sizeof(LIST));
active= (LIST**)shalloc(n*sizeof(LIST*));

seq pprintf("Building list of %d items using %d processors\n",2*n,p);

par_array(i,2*n){
element= (struct my_element*)malloc(sizeof(struct my_element));
element->contents= i;
slist[i].element= element;
}
par_array(i,2*n-1)farm update(ELT(slist,i),ELT(slist,i+1));
seq update(ELT(slist,2*n-1),NULL);

t= getct();
list_make(slist,2*n,FC1(void*)next,PR2 update);
check_list(slist,2*n);
t= getct()-t;
seq pprintf("Building time: %d\n",t);
showlist(slist,ss);


t= getct();
list_rank(slist,2*n);
t= getct()-t;
check_list(slist,2*n);

check_rank(slist,2*n);
seq pprintf("Ranking time: %d\n",t);


n1= n>>1;
n2= n-n1;
par_array(i,n1)active[i]= slist+(i<<1);
par_array(i,n2)active[n1+i]= slist+((i<<1)+1);
n1= n1>>1;
n3= n-(n1+n2);
force_sublist(active,n1,tlist,PR2 update);
check_list(tlist,n1);
check_rank(tlist,n1);
seq pprintf("Built sublist of size %d\n",n1);
showlist(tlist,ss);

force_sublist(active+n1,n2,tlist+n1,PR2 update);
check_list(tlist+n1,n2);
check_rank(tlist+n1,n2);
seq pprintf("Built sublist of size %d\n",n2);
showlist(tlist+n1,ss);

force_sublist(active+n1+n2,n3,tlist+n1+n2,PR2 update);
check_list(tlist+n1+n2,n3);
check_rank(tlist+n1+n2,n3);
seq pprintf("Built sublist of size %d\n",n3);
showlist(tlist+n1+n2,ss);

force_meshlist(slist+n,n);
list_reverse(slist+n,n);
list_move(slist+n,n,tlist+n,PR2 update);
check_list(tlist+n,n);
seq pprintf("Built sublist of size %d\n",n);
showlist(tlist+n,ss);


lsts[3]= tlist;szs[3]= n1;
lsts[2]= tlist+n1;szs[2]= n2;
lsts[1]= tlist+n1+n2;szs[1]= n3;
lsts[0]= tlist+n;szs[0]= n;
lists_move(lsts,szs,4,slist,2*n,PR2 update);
check_list(slist,2*n);
l= list_findends(slist,2*n,heads,tails);
seq printf("Found %d sublists\n",l);
showends(heads,tails,l);
list_splice(heads,tails,l);
seq pprintf("Lists spliced\n");
l= list_findends(slist,2*n,heads,tails);
seq printf("Found %d sublists\n",l);
showends(heads,tails,l);
check_list(slist,2*n);


t= getct();
list_rank(slist,2*n);
t= getct()-t;
check_list(slist,2*n);
check_rank(slist,2*n);
seq pprintf("Standard ranking time: %d\n",t);


t= getct();
wyllie(slist,2*n);
t= getct()-t;
check_list(slist,2*n);
check_rank(slist,2*n);
seq pprintf("Wyllie ranking time: %d\n",t);
}
}

/*:91*/
