/*37:*/
#line 1745 "merging.web"

#include <fork.h>
#include <io.h>
#include "pad.h"
#include "merge.h"
#include "prefix.h"
#include "checkers.h"


async int lt(pr int*x,pr int*y)
{
return*x<*y;
}

void main(void)
{
start{
sh int p= __STARTED_PROCS__;
sh int n,m;
sh int*x,*y,*z;
sh int I;

pr int i,j;
pr int low,high;
pr int s,t;

n= 1001;m= 2001;

x= (int*)shalloc(3*(n+m)*sizeof(int));
y= x+n;z= y+m;

proc(0)pprintf("Search and merge examples: n=%d, m=%d\n",n,m);

ppar_array(i,n)x[i]= 2*i;
ppar_array(i,m)y[i]= i;

t= getct();
merge(x,n,y,m,z);
t= getct()-t;

proc(0)pprintf("Merging sequences in parallel, time %d\n",t);

t= getct();
low= bin_search_low(ME*(m+n)/p,z,m+n);
high= bin_search_high(ME*(m+n)/p,z,m+n);
t= getct()-t;
pprintf("y=%d, low: %d high: %d, time %d\n",ME*(m+n)/p,z[low],z[high],t);

t= getct();
low= ordered_search_low(p/2*(m+n)/p,z,m+n);
high= ordered_search_high(p/2*(m+n)/p,z,m+n);
t= getct()-t;
proc(0)pprintf("y=%d, low: %d high: %d, time %d\n",
p/2*(m+n)/p,z[low],z[high],t);


proc(0)pprintf("Sorting %d elements\n",n);
random_array(x,n,y,m);
copy_array(x,y,n);
s= getct();
mergesort(x,n);
s= getct()-s;
check_order(x,n);
t= getct();
quicksort(y,n);
t= getct()-t;
scan_equal(x,y,n);
proc(0)pprintf("Mergesort %d, Quicksort %d\n",s,t);

random_array(x,n,y,m);

ppar_array(i,n){
x[i]= x[i]%n;
if(x[i]<0)x[i]+= n;
}
t= getct();
smallsort(x,n,n);
t= getct()-t;
check_order(x,n);
proc(0)pprintf("Sorting small integers %d\n",t);

random_array(x,n,y,m);
t= getct();
Mergesort(x,n,sizeof(int),y,FC2(int)lt);
t= getct()-t;
check_order(y,n);
proc(0)pprintf("Mergesort for arbitrary arrays %d\n",t);
}
}

/*:37*/
