/*4:*/
#line 218 "merging.web"

#include <fork.h>
#include <string.h>
#include <io.h>
#include "pad.h"
#include "prefix.h"
/*1:*/
#line 59 "merging.web"



extern async int bin_search_low(pr int y,pr int*x,pr int n);
extern async int bin_search_high(pr int y,pr int*x,pr int n);



extern sync int ordered_search_low(sh int y,sh int x[],sh int n);
extern sync int ordered_search_high(sh int y,sh int x[],sh int n);



extern async void
seq_merge(pr int x[],pr int n,pr int y[],pr int m,pr int z[]);
extern sync void
simple_merge(sh int x[],sh int n,sh int y[],sh int m,sh int z[]);
extern sync void
unbal_merge(sh int x[],sh int n,sh int y[],sh int m,sh int z[]);
extern sync void merge(sh int*x,sh int n,sh int*y,sh int m,sh int*z);



extern async void seq_mergesort(pr int x[],pr int n);
extern sync void mergesort(sh int x[],sh int n);
extern sync void unblocked_mergesort(sh int x[],sh int n);



extern async void seq_quicksort(pr int x[],pr int n);
extern sync void quicksort(sh int x[],sh int n);
extern sync void quicksort_it(sh int x[],sh int n);



extern sync void smallsort(sh int x[],sh int n,sh int c);
extern sync void smallperm(sh int keys[],sh int n,sh int c,sh int rank[]);




extern
async int Bin_search_low(pr void*y,pr void*x,pr int n,pr int size,
async bool(*cmp)(pr void*,pr void*));
extern
async int Bin_search_high(pr void*y,pr void*x,pr int n,pr int size,
async bool(*cmp)(pr void*,pr void*));
extern
async void Seq_merge(pr void*x,pr int n,pr void*y,pr int m,pr void*z,
pr int size,async bool(*cmp)(pr void*,pr void*));
extern
sync void Unbal_merge(sh void*x,sh int n,sh void*y,sh int m,sh void*z,
sh int size,async bool(*cmp)(pr void*,pr void*));
extern
sync void Merge(sh void*x,sh int n,sh void*y,sh int m,sh void*z,
sh int size,async bool(*cmp)(pr void*,pr void*));
extern
sync void Mergesort(sh void*x,sh int n,sh int size,sh void*xx,
async bool(*cmp)(pr void*,pr void*));
extern
sync void Unblocked_Mergesort(sh void*x,sh int n,sh int size,sh void*xx,
async bool(*cmp)(pr void*,pr void*));

/*:1*/
#line 224 "merging.web"


/*:4*//*6:*/
#line 255 "merging.web"

async int bin_search_low(pr int y,pr int*x,pr int n)
{
pr int i,m;

if(y>x[n-1])return n;

i= 0;
while(n>1){
m= n>>1;
if(y>x[m-1]){
x= x+m;
i= i+m;
n= n-m;
}else n= m;
}
return i;
}

async int bin_search_high(pr int y,pr int*x,pr int n)
{
pr int i,m;

if(y<x[0])return-1;
i= 0;
while(n>1){
m= n>>1;
if(y>=x[m]){
x= x+m;
i= i+m;
n= n-m;
}else n= m;
}
return i;
}

/*:6*//*7:*/
#line 328 "merging.web"

sync int search_low_rec(sh int y,sh int x[],sh int n,sh int p)
{
sh int i;
pr int k,nn;

if(n<=p){

farm
if(ME<n)if(x[ME-1]<y&&y<=x[ME])i= ME;
}
else{

nn= n/p;
k= ME*nn;
if(ME==p-1)nn= n-k;
farm
if(x[k-1]<y&&(y<=x[k+nn-1])){

n= nn;x= x+k;i= k;
}
i= i+search_low_rec(y,x,n,p);
}
return i;
}

sync int ordered_search_low(sh int y,sh int x[],sh int n)
{
sh int p= groupsize();

if(p==1)return bin_search_low(y,x,n);

if(y<=x[0])return 0;else if(y>x[n-1])return n;
return search_low_rec(y,x+1,n-1,p)+1;
}

/*:7*//*8:*/
#line 365 "merging.web"

sync int search_high_rec(sh int y,sh int x[],sh int n,sh int p)
{
sh int i;
pr int k,nn;

if(n<=p){

farm if(ME<n)if(x[ME]<=y&&y<x[ME+1])i= ME;
}
else{

nn= n/p;
k= ME*nn;
if(ME==p-1)nn= n-k;
farm
if(x[k]<=y&&(y<x[k+nn])){

n= nn;x= x+k;i= k;
}
i= i+search_high_rec(y,x,n,p);
}
return i;
}

sync int ordered_search_high(sh int y,sh int x[],sh int n)
{
sh int p= groupsize();

if(p==1)return bin_search_high(y,x,n);

if(y<x[0])return-1;else if(y>=x[n-1])return n-1;
return search_high_rec(y,x,n-1,p);
}

/*:8*//*11:*/
#line 485 "merging.web"

async void seq_merge(pr int x[],pr int n,pr int y[],pr int m,pr int z[])
{
pr int i,j,k;

i= 0;j= 0;k= 0;

while(i<n&&j<m)
if(x[i]<=y[j])z[k++]= x[i++];else z[k++]= y[j++];

while(i<n)z[k++]= x[i++];
while(j<m)z[k++]= y[j++];
}

/*:11*//*12:*/
#line 527 "merging.web"

sync void simple_merge(sh int x[],sh int n,sh int y[],sh int m,sh int z[])
{


pr int xx,yy;

farm{
if(ME<n){

xx= x[ME];
z[ME+bin_search_low(xx,y,m)]= xx;
}
if(ME<m){

yy= y[ME];
z[ME+bin_search_high(yy,x,n)+1]= yy;
}
}
}

/*:12*//*13:*/
#line 575 "merging.web"

sync void unbal_merge(sh int x[],sh int n,sh int y[],sh int m,sh int z[])
{
sh int p= groupsize();
sh int*yindex;
sh int*xrank;

pr int i,j;

yindex= (int*)shalloc((m+1+n)*sizeof(int));
xrank= yindex+m+1;


ppar_array(i,n){
j= bin_search_low(x[i],y,m);
xrank[i]= j;
z[j+i]= x[i];
}


ppar_array(i,m)yindex[i]= 0;

ppar_array(i,n-1)if(xrank[i]!=xrank[i+1])yindex[xrank[i]]= i+1;
if(i==n-1)yindex[xrank[i]]= n;

for(i= ME+1;i<n;i+= p)
if(xrank[i-1]!=xrank[i])yindex[xrank[i]]-= i;


prefix_add(yindex,m,yindex,0);


ppar_array(i,m)z[i+yindex[i]]= y[i];
shallfree();
}

/*:13*//*14:*/
#line 704 "merging.web"

#define C_merge 0

struct ranks{
int reprank;
int firstrank,ranksize;
};

sync void merge(sh int*x,sh int n,sh int*y,sh int m,sh int*z)
{
sh int p= groupsize();

sh MY_SEG*xseg,*yseg;
sh struct ranks*xrank,*yrank;
sh int*xrep,*yrep;
pr int i,j;



if(n<p||n<=C_merge*m){
unbal_merge(x,n,y,m,z);
return;
}
if(m<p||m<=C_merge*n){
unbal_merge(y,m,x,n,z);
return;
}



xrep= (int*)shalloc(2*p*sizeof(int));
yrep= xrep+p;
xseg= (MY_SEG*)shalloc(2*(p+1)*sizeof(MY_SEG));
yseg= xseg+p+1;
xrank= (struct ranks*)shalloc(2*(p+1)*sizeof(struct ranks));
yrank= xrank+p+1;

mysegment(n,xseg+ME);mysegment(m,yseg+ME);

/*15:*/
#line 752 "merging.web"



xrep[ME]= x[xseg[ME].index];
yrep[ME]= y[yseg[ME].index];

if(ME==p-1){


xseg[p].index= n;
xseg[p].size= 0;
xrank[p].reprank= p-1;
xrank[p].firstrank= m;

yseg[p].index= m;
yseg[p].size= 0;
yrank[p].reprank= p-1;
yrank[p].firstrank= n;
}

/*:15*/
#line 743 "merging.web"

/*16:*/
#line 774 "merging.web"



i= bin_search_low(xrep[ME],yrep,p)-1;

xrank[ME].reprank= i;

j= bin_search_high(yrep[ME],xrep,p);
yrank[ME].reprank= j;

/*:16*/
#line 744 "merging.web"

/*17:*/
#line 785 "merging.web"



if(i<0)xrank[ME].firstrank= 0;
else
xrank[ME].firstrank= yseg[i].index+


bin_search_low(xrep[ME],y+yseg[i].index,yseg[i].size);

if(j<0)yrank[ME].firstrank= 0;
else

yrank[ME].firstrank= xseg[j].index+1+

bin_search_high(yrep[ME],x+xseg[j].index,xseg[j].size);

/*:17*/
#line 745 "merging.web"

/*18:*/
#line 803 "merging.web"



if(i!=xrank[ME+1].reprank){
xseg[ME].size= yrank[i+1].firstrank-xseg[ME].index;
xrank[ME].ranksize= yseg[i+1].index-xrank[ME].firstrank;
}else{
xrank[ME].ranksize= xrank[ME+1].firstrank-xrank[ME].firstrank;
}

if(j!=yrank[ME+1].reprank){
yseg[ME].size= xrank[j+1].firstrank-yseg[ME].index;
yrank[ME].ranksize= xseg[j+1].index-yrank[ME].firstrank;
}else{
yrank[ME].ranksize= yrank[ME+1].firstrank-yrank[ME].firstrank;
}
#ifdef TESTING
pprintf("X[%d %d] Y[%d %d]\n",
xseg[ME].index,xseg[ME].index+xseg[ME].size,
xrank[ME].firstrank,xrank[ME].firstrank+xrank[ME].ranksize);
pprintf("Y[%d %d] X[%d %d]\n",
yseg[ME].index,yseg[ME].index+yseg[ME].size,
yrank[ME].firstrank,yrank[ME].firstrank+yrank[ME].ranksize);
#endif

/*:18*/
#line 746 "merging.web"

/*19:*/
#line 829 "merging.web"


farm{
seq_merge(x+xseg[ME].index,xseg[ME].size,
y+xrank[ME].firstrank,xrank[ME].ranksize,
z+xseg[ME].index+xrank[ME].firstrank);
seq_merge(y+yseg[ME].index,yseg[ME].size,
x+yrank[ME].firstrank,yrank[ME].ranksize,
z+yseg[ME].index+yrank[ME].firstrank);
}

/*:19*/
#line 747 "merging.web"

shallfree();
}

/*:14*//*21:*/
#line 1031 "merging.web"

struct sortpair{
int c1,c2;
};

async bool sortcmp(pr struct sortpair*x,pr struct sortpair*y)

{
if(x->c1<y->c1)return TRUE;
else if(x->c1==y->c1&&x->c2<y->c2)return TRUE;
else return FALSE;
}

sync void unblocked_mergesort(sh int x[],sh int n)
{
sh int p= groupsize();

sh struct sortpair*x1,*x2;
sh struct sortpair*y,*z;
sh int n1,n2;
sh int c;

pr int i;

x1= (struct sortpair*)shalloc(2*n*sizeof(struct sortpair));


proc(0){
n2= n>>1;
n1= n-n2;
x2= x1+n1;y= x1+n;
c= n1;
}


ppar_array(i,n){
x1[i].c1= i;
x1[i].c2= x[i];
}
while(c!=0){

ppar_array(i,n2)x2[i].c1= x2[i].c1-c;
Merge(x1,n1,x2,n2,y,sizeof(struct sortpair),FC2(int)sortcmp);

proc(0){
z= x1;x1= y;y= z;
x2= x1+n1;
c= x2[0].c1;
}
}


ppar_array(i,n)x[i]= x1[i].c2;
shallfree();
}

/*:21*//*22:*/
#line 1110 "merging.web"

sync void mergesort(sh int x[],sh int n)
{
sh int p= groupsize();

sh struct sortpair*x1,*x2;
sh struct sortpair*y,*z;
sh int n1,n2;
sh int c,prevc;
sh MY_SEG*segment;
pr int i;

x1= (struct sortpair*)shalloc(2*n*sizeof(struct sortpair));
segment= (MY_SEG*)shalloc(p*sizeof(MY_SEG));


mysegment(n,segment+ME);


farm seq_mergesort(x+segment[ME].index,segment[ME].size);
for(i= 0;i<segment[ME].size;i++){
(x1+segment[ME].index)[i].c1= ME;
(x1+segment[ME].index)[i].c2= (x+segment[ME].index)[i];
}
proc(0){
prevc= p;c= (p+1)>>1;
n1= segment[c-1].index+segment[c-1].size;
n2= n-n1;
x2= x1+n1;
y= x1+n;
}
while(prevc>1){

ppar_array(i,n2)x2[i].c1= x2[i].c1-c;
Merge(x1,n1,x2,n2,y,sizeof(struct sortpair),FC2(int)sortcmp);
/*23:*/
#line 1175 "merging.web"


if(ME<c){
#ifdef TESTING
pprintf("%d\n",x1[segment[ME].index].c1);
#endif
if(ME+c<prevc){
segment[ME].index= segment[ME].index+segment[ME+c].index-n1;
segment[ME].size= segment[ME].size+segment[ME+c].size;
}else{

segment[ME].index= segment[ME].index+n2;
}
}

/*:23*/
#line 1145 "merging.web"

proc(0){

prevc= c;c= (c+1)>>1;
n1= segment[c-1].index+segment[c-1].size;
n2= n-n1;
z= x1;x1= y;y= z;
x2= x1+n1;
}
}

ppar_array(i,n)x[i]= x1[i].c2;
shallfree();
}

/*:22*//*24:*/
#line 1197 "merging.web"

async void seq_mergesort(pr int in[],pr int n)
{
pr int i,m,nn;
pr int*x,*y,*z;

x= in;
y= (int*)malloc(n*sizeof(int));

nn= 1;
while(nn<n){
m= nn+nn;
for(i= 0;i+m<n;i+= m)seq_merge(x+i,nn,x+i+nn,nn,y+i);

if(i+nn<n)seq_merge(x+i,nn,x+i+nn,n-(i+nn),y+i);
else for(;i<n;i++)y[i]= x[i];

z= x;x= y;y= z;
nn= m;
}
if(x!=in)
for(i= 0;i<n;i++)in[i]= x[i];
free();
}

/*:24*//*26:*/
#line 1248 "merging.web"

/*27:*/
#line 1296 "merging.web"

#define C_quicksort 5 
/*33:*/
#line 1549 "merging.web"

async int median3(pr int x[],pr int i1,pr int i2,pr int i3)
{
pr int i;

i= i2;
if(x[i2]<x[i1]){
if(x[i1]<x[i3])i= i1;else if(x[i3]>x[i2])i= i3;
}else if(x[i3]<x[i1])i= i1;else if(x[i3]<x[i2])i= i3;

return i;
}

/*:33*/
#line 1298 "merging.web"

sync void qs_rec(sh int x[],sh int index[],sh int color[],sh int y[],
sh int n,sh int p)
{
sh int pivot;
sh int smaller,equal,larger,m;
sh int p_smaller,p_larger;
sh int csizes[3];
pr int group,offset;
pr int i;

if(p==1||n<C_quicksort){


proc(0)farm seq_quicksort(x,n);
}else{
proc(0){

i= median3(x,0,n>>1,n-1);
pivot= x[i];
}
ppar_array(i,n){

if(x[i]<pivot)color[i]= 0;
else if(x[i]==pivot)color[i]= 1;
else color[i]= 2;
index[i]= 1;
}
colorprefix_add(index,n,color,3,csizes);
proc(0){
smaller= csizes[0];larger= csizes[2];


p_smaller= (p*smaller)/(smaller+larger);

if(p_smaller==0)p_smaller= 1;else if(p_smaller==p)p_smaller= p-1;
p_larger= p-p_smaller;

csizes[2]= csizes[0]+csizes[1];m= csizes[2];
csizes[1]= csizes[0];
csizes[0]= 0;
}

ppar_array(i,n)index[i]= index[i]+csizes[color[i]]-1;
permute_array(x,y,n,index);
copy_array(y,x,n);

if(ME<p_smaller){
group= 0;
offset= 0;
}else{
group= 1;
offset= p_smaller;
}

fork(2;MY= group;ME= ME-offset)
if(MY==0)qs_rec(x,index,color,y,smaller,p_smaller);else
qs_rec(x+m,index+m,color+m,y+m,larger,p_larger);
}
}

/*:27*/
#line 1249 "merging.web"

sync void quicksort(sh int x[],sh int n)
{
sh int p= groupsize();
sh int*index;

index= (int*)shalloc(3*n*sizeof(int));
qs_rec(x,index,index+n,index+2*n,n,p);
shallfree();
}

/*:26*//*28:*/
#line 1401 "merging.web"

sync void quicksort_it(sh int x[],sh int n)
{
sh int p= groupsize();
sh int*segstart,*segsize,*newsize,*index;
sh int*pivot,*y;
pr int i,last;
sh int segments= 1;

segstart= (int*)shalloc(6*n*sizeof(int));
segsize= segstart+n;newsize= segsize+n;index= newsize+n;
pivot= index+n;y= pivot+n;


ppar_array(i,n){
segsize[i]= 0;newsize[i]= 0;
segstart[i]= FALSE;
}
proc(0){
segsize[0]= n;
segstart[0]= TRUE;
}

while(segments<n){

ppar_array(i,n){
if(segstart[i]){
if(segsize[i]>2)
pivot[i]= x[i+median3(x+i,0,segsize[i]>>1,segsize[i]-1)];
else pivot[i]= x[i];
}
}

group_broadcast(pivot,n,segstart,&segments);
/*29:*/
#line 1457 "merging.web"

ppar_array(i,n){

if(segstart[i])index[i]= i-1;else index[i]= 0;
if(x[i]<pivot[i])index[i]= index[i]+1;
}

group_prefix_add(index,n,index,segstart,&segments);

ppar_array(i,n)if(x[i]<pivot[i])y[index[i]]= x[i];

/*:29*/
#line 1435 "merging.web"

/*30:*/
#line 1469 "merging.web"

ppar_array(i,n){
if(segstart[i]){
last= i+segsize[i]-1;
newsize[i]= index[last]+1-i;
index[i]= index[last];
}


if(!segstart[i])index[i]= 0;
if(x[i]==pivot[i])index[i]= index[i]+1;
}

group_prefix_add(index,n,index,segstart,&segments);


ppar_array(i,n)if(x[i]==pivot[i]){
y[index[i]]= x[i];
newsize[index[i]]= 1;
}

/*:30*/
#line 1436 "merging.web"

/*31:*/
#line 1491 "merging.web"

ppar_array(i,n){
if(segstart[i]){
last= i+segsize[i]-1;
if(index[last]<last)newsize[index[last]+1]= last-index[last];
index[i]= index[last];
}

if(!segstart[i])index[i]= 0;
if(x[i]>pivot[i])index[i]= index[i]+1;
}

group_prefix_add(index,n,index,segstart,&segments);

ppar_array(i,n)if(x[i]>pivot[i])y[index[i]]= x[i];

/*:31*/
#line 1437 "merging.web"



ppar_array(i,n){
x[i]= y[i];
segsize[i]= newsize[i];
if(segsize[i]>0)segstart[i]= TRUE;
}

segments= groups(segstart,n);
}
shallfree();
}

/*:28*//*32:*/
#line 1513 "merging.web"

async void seq_quicksort(pr int x[],pr int n)
{
pr int pivot;
pr int y;
pr int m;
pr int n1,n2,n3;

if(n>2){
m= median3(x,0,n/2,n-1);
pivot= x[m];


n1= 0;n2= 0;n3= n;
while(n2<n3){
y= x[n2];
if(y<pivot){
x[n2]= x[n1];x[n1]= y;
n2= n2+1;n1= n1+1;
}else if(y>pivot){
n3= n3-1;
x[n2]= x[n3];x[n3]= y;
}else n2= n2+1;
}
seq_quicksort(x,n1);seq_quicksort(x+n3,n-n3);
}else if(n>1){

if(x[0]>x[1]){
y= x[0];x[0]= x[1];x[1]= y;
}
}
}

/*:32*//*34:*/
#line 1598 "merging.web"

sync void smallsort(sh int x[],sh int n,sh int c)
{
sh int p= groupsize();
sh int*rank;
sh int*y;
pr int i;

rank= (int*)shalloc(n*sizeof(int));
y= (int*)shalloc(n*sizeof(int));

smallperm(x,n,c,rank);
permute_array(x,y,n,rank);
copy_array(y,x,n);
shallfree();
}

/*:34*//*35:*/
#line 1621 "merging.web"

sync void smallperm(sh int keys[],sh int n,sh int c,sh int rank[])
{
sh int p= groupsize();
sh int*count;
pr int i;

count= (int*)shalloc(c*sizeof(int));

ppar_array(i,n)rank[i]= 1;
colorprefix_add(rank,n,keys,c,count);
preprefix_add(count,c,count,0);

ppar_array(i,n)rank[i]= rank[i]-1+count[keys[i]];
shallfree();
}

/*:35*//*39:*/
#line 1850 "merging.web"

async int Bin_search_low(pr void*y,pr void*x,pr int n,pr int size,
async bool(*cmp)(pr void*,pr void*))
{
pr int i,m;

if((*cmp)((char*)x+(n-1)*size,y))return n;
i= 0;
while(n>1){
m= n/2;
if((*cmp)((char*)x+(m-1)*size,y)){
x= (char*)x+m*size;
i= i+m;
n= n-m;
}else n= m;
}
return i;
}

async int Bin_search_high(pr void*y,pr void*x,pr int n,pr int size,
async bool(*cmp)(pr void*,pr void*))
{
pr int i,m;

if((*cmp)(y,x))return-1;
i= 0;
while(n>1){
m= n/2;
if(!(*cmp)(y,(char*)x+m*size)){
x= (char*)x+m*size;
i= i+m;
n= n-m;
}else n= m;
}
return i;
}

async void Seq_merge(pr void*x,pr int n,pr void*y,pr int m,pr void*z,
pr int size,async bool(*cmp)(pr void*,pr void*))
{
pr int i,j,k;

i= 0;j= 0;k= 0;
n= n*size;m= m*size;

while(i<n&&j<m)
if(!(*cmp)((char*)y+j,(char*)x+i)){
memcpy((char*)z+k,(char*)x+i,size);
k= k+size;i= i+size;
}else{
memcpy((char*)z+k,(char*)y+j,size);
k= k+size;j= j+size;
}

while(i<n){
memcpy((char*)z+k,(char*)x+i,size);
k= k+size;i= i+size;
}
while(j<m){
memcpy((char*)z+k,(char*)y+j,size);
k= k+size;j= j+size;
}
}

/*:39*//*40:*/
#line 1915 "merging.web"

sync void Unbal_merge(sh void*x,sh int n,sh void*y,sh int m,sh void*z,
sh int size,async bool(*cmp)(pr void*,pr void*))
{
sh int p= groupsize();
sh int*yindex;
sh int*xrank;

pr int i,j;

yindex= (int*)shalloc((m+1+n)*sizeof(int));
xrank= yindex+m+1;



ppar_array(i,n){
j= Bin_search_low((char*)x+i*size,y,m,size,cmp);
xrank[i]= j;
memcpy((char*)z+(j+i)*size,(char*)x+i*size,size);
}


ppar_array(i,m)yindex[i]= 0;

ppar_array(i,n-1)if(xrank[i]!=xrank[i+1])yindex[xrank[i]]= i+1;
if(i==n-1)yindex[xrank[i]]= n;

for(i= ME+1;i<n;i+= p)
if(xrank[i-1]!=xrank[i])yindex[xrank[i]]-= i;


prefix_add(yindex,m,yindex,0);


ppar_array(i,m)
memcpy((char*)z+(i+yindex[i])*size,(char*)y+i*size,size);
shallfree();
}

sync void Merge(sh void*x,sh int n,sh void*y,sh int m,sh void*z,
sh int size,async bool(*cmp)(pr void*,pr void*))
{
sh int p= groupsize();

sh MY_SEG*xseg,*yseg;
sh struct ranks*xrank,*yrank;
sh char*xrep,*yrep;

pr int i,j;



if(n<p||n<=C_merge*m){
Unbal_merge(x,n,y,m,z,size,cmp);
return;
}
if(m<p||m<=C_merge*n){
Unbal_merge(y,m,x,n,z,size,cmp);
return;
}

xrep= (char*)shalloc(2*p*size);
yrep= xrep+p*size;
xseg= (MY_SEG*)shalloc(2*(p+1)*sizeof(MY_SEG));
yseg= xseg+p+1;
xrank= (struct ranks*)shalloc(2*(p+1)*sizeof(struct ranks));
yrank= xrank+p+1;

mysegment(n,xseg+ME);mysegment(m,yseg+ME);



memcpy(xrep+ME*size,(char*)x+xseg[ME].index*size,size);
memcpy(yrep+ME*size,(char*)y+yseg[ME].index*size,size);

if(ME==p-1){

xseg[p].index= n;
xseg[p].size= 0;
xrank[p].reprank= p-1;
xrank[p].firstrank= m;

yseg[p].index= m;
yseg[p].size= 0;
yrank[p].reprank= p-1;
yrank[p].firstrank= n;
}



i= Bin_search_low(xrep+ME*size,yrep,p,size,cmp);
i= i-1;
xrank[ME].reprank= i;

j= Bin_search_high(yrep+ME*size,xrep,p,size,cmp);
yrank[ME].reprank= j;



if(i<0)xrank[ME].firstrank= 0;
else
xrank[ME].firstrank= yseg[i].index+
Bin_search_low(xrep+ME*size,
(char*)y+yseg[i].index*size,yseg[i].size,size,cmp);

if(j<0)yrank[ME].firstrank= 0;
else
yrank[ME].firstrank= xseg[j].index+1+
Bin_search_high(yrep+ME*size,
(char*)x+xseg[j].index*size,xseg[j].size,size,cmp);



if(i!=xrank[ME+1].reprank){
xseg[ME].size= yrank[i+1].firstrank-xseg[ME].index;
xrank[ME].ranksize= 
yseg[i+1].index-xrank[ME].firstrank;
}else{
xrank[ME].ranksize= xrank[ME+1].firstrank-xrank[ME].firstrank;
}

if(j!=yrank[ME+1].reprank){
yseg[ME].size= xrank[j+1].firstrank-yseg[ME].index;
yrank[ME].ranksize= 
xseg[j+1].index-yrank[ME].firstrank;
}else{
yrank[ME].ranksize= yrank[ME+1].firstrank-yrank[ME].firstrank;
}
#ifdef TESTING
pprintf("X[%d %d] Y[%d %d]\n",
xseg[ME].index,xseg[ME].index+xseg[ME].size,
xrank[ME].firstrank,xrank[ME].firstrank+xrank[ME].ranksize);
pprintf("Y[%d %d] X[%d %d]\n",
yseg[ME].index,yseg[ME].index+yseg[ME].size,
yrank[ME].firstrank,yrank[ME].firstrank+yrank[ME].ranksize);
#endif



farm{
Seq_merge((char*)x+xseg[ME].index*size,xseg[ME].size,
(char*)y+xrank[ME].firstrank*size,xrank[ME].ranksize,
(char*)z+(xseg[ME].index+xrank[ME].firstrank)*size,
size,cmp);
Seq_merge((char*)y+yseg[ME].index*size,yseg[ME].size,
(char*)x+yrank[ME].firstrank*size,yrank[ME].ranksize,
(char*)z+(yseg[ME].index+yrank[ME].firstrank)*size,
size,cmp);
}
shallfree();
}

/*:40*//*41:*/
#line 2068 "merging.web"


async bool(*oldcmp)(pr void*,pr void*);

struct Sortpair{
int c1;
void*c2;
};

async bool Sortcmp(pr struct Sortpair*x,pr struct Sortpair*y)

{
if(x->c1<y->c1)return TRUE;
else if(x->c1==y->c1&&(*oldcmp)(x->c2,y->c2))return TRUE;
else return FALSE;
}

sync void Unblocked_Mergesort(sh void*x,sh int n,sh int size,sh void*xx,
async bool(*cmp)(pr void*,pr void*))
{
sh int p= groupsize();

sh struct Sortpair*x1,*x2;
sh struct Sortpair*y,*z;
sh int n1,n2;
sh int c;

pr int i;

oldcmp= cmp;
x1= (struct Sortpair*)shalloc(2*n*sizeof(struct Sortpair));


proc(0){
n2= n>>1;
n1= n-n2;
x2= x1+n1;y= x1+n;
c= n1;
}

ppar_array(i,n){
x1[i].c1= i;
x1[i].c2= (char*)x+i*size;
}
while(c!=0){

ppar_array(i,n2)x2[i].c1= x2[i].c1-c;
Merge(x1,n1,x2,n2,y,sizeof(struct Sortpair),FC2(int)Sortcmp);

proc(0){
z= x1;x1= y;y= z;
x2= x1+n1;
c= x2[0].c1;
}
}

ppar_array(i,n)memcpy((char*)xx+i*size,x1[i].c2,size);
shallfree();
}

async void Seq_mergesort(pr void*in,pr int n,pr int size,
async bool(*cmp)(pr void*,pr void*))
{
pr int i,m,nn;
pr char*x,*y,*z;

x= in;
y= (char*)malloc(n*size);

nn= 1;
while(nn<n){
m= nn+nn;
for(i= 0;i+m<n;i+= m)
Seq_merge(x+i*size,nn,x+(i+nn)*size,nn,y+i*size,size,cmp);

if(i+nn<n)
Seq_merge(x+i*size,nn,x+(i+nn)*size,n-(i+nn),y+i*size,size,cmp);
else for(;i<n;i++)memcpy(y+i*size,x+i*size,size);

z= x;x= y;y= z;
nn= m;
}
if(x!=in)

for(i= 0;i<n;i++)memcpy((char*)in+i*size,x+i*size,size);
free();
}

sync void Mergesort(sh void*x,sh int n,sh int size,sh void*xx,
async bool(*cmp)(pr void*,pr void*))
{
sh int p= groupsize();

sh struct Sortpair*x1,*x2;
sh struct Sortpair*y,*z;
sh int n1,n2;
sh int c,prevc;

sh MY_SEG*segment;
pr int i;

oldcmp= cmp;
x1= (struct Sortpair*)shalloc(2*n*sizeof(struct Sortpair));
segment= (MY_SEG*)shalloc(p*sizeof(MY_SEG));


mysegment(n,segment+ME);


farm Seq_mergesort((char*)x+segment[ME].index*size,
segment[ME].size,size,cmp);
for(i= 0;i<segment[ME].size;i++){
(x1+segment[ME].index)[i].c1= ME;

(x1+segment[ME].index)[i].c2= (char*)x+(segment[ME].index+i)*size;
}
proc(0){
prevc= p;c= (p+1)>>1;
n1= segment[c-1].index+segment[c-1].size;
n2= n-n1;
x2= x1+n1;
y= x1+n;
}
while(prevc>1){

ppar_array(i,n2)x2[i].c1= x2[i].c1-c;
Merge(x1,n1,x2,n2,y,sizeof(struct Sortpair),FC2(int)Sortcmp);

if(ME<c){
#ifdef TESTING
pprintf("%d\n",x1[segment[ME].index].c1);
#endif
if(ME+c<prevc){
segment[ME].index= segment[ME].index+segment[ME+c].index-n1;
segment[ME].size= segment[ME].size+segment[ME+c].size;
}else{

segment[ME].index= segment[ME].index+n2;
}
}
proc(0){

prevc= c;c= (c+1)>>1;
n1= segment[c-1].index+segment[c-1].size;
n2= n-n1;
z= x1;x1= y;y= z;
x2= x1+n1;
}
}

ppar_array(i,n)memcpy((char*)xx+i*size,x1[i].c2,size);
shallfree();
}

/*:41*/
