/* PAD header file */

/* Jesper Larsson Traff, April 1995 */

/* Machine type: EREW/CREW/CRCW */

#ifndef PADheader
#define PADheader

#define CREW

#define MAX_PROC 4096 /* maximum number of hardware processors */

/* Boolean type */

#define TRUE  1
#define FALSE 0

typedef int bool;

#define odd(n)  (((n)&1)==1)
#define even(n) (((n)&1)==0)

/* For use with CWEB */

#define ME $
#define MY @

/* Iterators */

#define proc(p) if (ME==p)
#define ppar_array(i,n) for (i=ME; i<(n); i+=p)
#define ppar_arrayseg(i,f,l) for (i=ME+(f); i<(f)+(l); i+=p)
#define prap_array(i,n) for (i=(n)-1-ME; i>=0; i-=p)
#define prap_arrayseg(i,f,l) for (i=(f)+(l)-1-ME; i>=(f); i-=p)

#define ppar_edges(e,T) for(e=(T)->edges+ME;e<(T)->endedge;e+=p)
#define ppar_nodes(v,T) for(v=(T)->nodes+ME;v<(T)->endnode;v+=p)

#define ppar_item(e,n,L) for (e=(L)+ME; e<(L)+(n); e+=p)

/* type casting macros for function parameters */

#define FC1(type) (type (*)(void*)) /* function with one argument */
#define FC2(type) (type (*)(void*,void*)) /* function with two arguments */
#define FC3(type) (type (*)(void*,void*,void*)) /* function with three arguments */

#define PR1 (void (*)(void*)) /* procedure with one argument */
#define PR2 (void (*)(void*,void*)) /* procedure with two arguments */
#define PR3 (void (*)(void*,void*,void*)) /* procedure with three arguments */

#endif
