/*14:*/
#line 370 "ranking.web"

#include <fork.h>
#include <io.h>
#include <string.h>
#include <math.h>
#include "pad.h"
#include "prefix.h"
#include "merge.h"

/*11:*/
#line 313 "ranking.web"

enum estatus{PAD_neutral,PAD_active,PAD_subject,
PAD_ruler,PAD_removed,PAD_special,PAD_marked,PAD_blocked};

typedef struct list_struct
{
void*element;
struct list_struct*succ,*pred;
struct list_struct*next;
struct list_struct*last;
int rank;
int serial;
int color;
enum estatus status;
int util;
}LIST;

/*:11*/
#line 379 "ranking.web"

/*12:*/
#line 338 "ranking.web"

#define par_item(e,n,L) for (e= (L)+ME;e<(L)+(n);e+= parentgroupsize())
#define par_list(e,i,n,L) \
for (i= ME,e= (i<n)?ELT(L,i):NULL; e; i+= parentgroupsize(),e= (i<n)?ELT(L,i):NULL)

/*:12*/
#line 380 "ranking.web"

/*13:*/
#line 351 "ranking.web"

#define list_elt(list,i) (list[i].element) 
#define elt_rank(list,i) (list[i].rank) 
#define elt_succ(list,i) (list[i].succ) 
#define elt_pred(list,i) (list[i].pred) 



#define ELT(list,i) (list[i].element) 
#define RANK(e) ((LIST *) (e))->rank 
#define NEXT(e) ((LIST *) (e))->succ->element 
#define PREV(e) ((LIST *) (e))->pred->element 
#define TAIL(e) (((LIST *) (e))->succ==NULL)  
#define HEAD(e) (((LIST *) (e))->pred==NULL)  

/*:13*/
#line 381 "ranking.web"

/*16:*/
#line 400 "ranking.web"

#define list_alloc(n) seq (LIST *) shmalloc(n*sizeof(LIST))
#define list_dealloc(list) seq shfree(list)

/*:16*//*26:*/
#line 733 "ranking.web"

#define list_aorder(L,n,f) list_revorder(L,n,f)

/*:26*/
#line 382 "ranking.web"

/*3:*/
#line 93 "ranking.web"

/*4:*/
#line 104 "ranking.web"

extern sync void link_up(sh LIST list[],pr void*element);
extern sync void list_make(sh LIST list[],sh int n,
async void*(*next)(void*),
async void(*up)(void*,void*));
extern sync void list_restore(sh LIST list[],sh int n,
async void(*up)(void*,void*));

/*:4*/
#line 94 "ranking.web"

/*5:*/
#line 113 "ranking.web"

extern sync void list_copy(sh LIST slist[],sh int n,sh LIST tlist[]);
extern sync void list_move(sh LIST slist[],sh int n,sh LIST tlist[],
async void(*up)(void*,void*));
extern sync void lists_move(sh LIST*lists[],sh int n[],sh int k,
sh LIST list[],sh int nn,
async void(*up)(void*,void*));
extern sync void sublist_move(sh LIST*active[],sh int n,sh LIST list[],
async void(*up)(void*,void*));
extern sync int list_findends(sh LIST list[],sh int n,
sh LIST*heads[],sh LIST*tails[]);
extern sync void list_splice(sh LIST*heads[],sh LIST*tails[],sh int k);
extern sync void list_setlink(sh LIST list[],sh int n,sh LIST*item);

extern sync void list_rankorder(sh LIST list[],sh int n,
async void(*up)(void*,void*));
extern sync void list_revorder(sh LIST list[],sh int n,
async void(*up)(void*,void*));
extern sync void list_reverse(sh LIST list[],sh int n);

/*:5*/
#line 95 "ranking.web"

/*6:*/
#line 134 "ranking.web"

extern sync void list_rank(sh LIST list[],sh int n);
extern sync void wyllie(sh LIST list[],sh int n);
extern sync void krs_rank(sh LIST list[],sh int n);
extern sync void KRS_rank(sh LIST list[],sh int n);
extern sync void cv_rank(sh LIST list[],sh int n);
extern sync void am_rank(sh LIST list[],sh int n);
extern sync void AM_rank(sh LIST list[],sh int n);
extern async void seq_rank(LIST list[],int n);

/*:6*/
#line 96 "ranking.web"

/*7:*/
#line 146 "ranking.web"

extern sync void color_star(sh LIST*active[],sh int n);
extern sync void color(sh LIST*active[],sh int n);
extern sync void ind_set(sh LIST*active[],sh int independent[],sh int n);
extern sync void ruling_set(pr LIST*e);

/*:7*/
#line 97 "ranking.web"

/*8:*/
#line 154 "ranking.web"

extern sync void list_getrank(sh LIST list[],sh int n,sh int permutation[]);
extern sync void list_rerank(sh LIST*heads[],sh int k,sh int newrank[],
sh LIST list[],sh int n);
extern sync void permute_list(sh int permutation[],sh int n,sh LIST list[],
async void(*up)(void*,void*));
extern sync void force_list(sh int cycle[],sh int n,
sh LIST list[],sh LIST*head);
extern sync void force_sublist(sh LIST*sublist[],sh int n,sh LIST list[],
async void(*up)(void*,void*));
extern sync void force_seqlist(sh LIST list[],sh const int n);
extern sync void force_meshlist(sh LIST list[],sh int n);
extern sync void force_randomlist(sh LIST list[],sh int n,sh LIST*head);

extern
sync void apply_listfunc(sh LIST list[],sh int n,async void(*f)(void*));

/*:8*/
#line 98 "ranking.web"

/*9:*/
#line 174 "ranking.web"

extern
sync void jump_init(sh LIST list[],sh int n,async void(*init)(void*));
extern
sync void jump(sh LIST list[],sh int n,
async void(*compute)(void*,void*));
extern
sync void jump_safe(sh LIST list[],sh int n,
async void(*compute)(void*,void*),
async void(*copy)(void*));
extern
sync void Jump(sh void*linked,sh int n,sh int esize,
async void(*compute)(void*,void*),
async void*(*next)(void*),
async void(*up)(void*,void*));
extern
sync void Wyllie(sh void*linked,sh int n,sh int esize,
async void(*compute)(void*,void*),
async void*(*next)(void*),
async void(*up)(void*,void*));
extern
sync void Jump_safe(sh void*linked,sh int n,sh int esize,
async void(*compute)(void*,void*),
async void*(*next)(void*),
async void(*up)(void*,void*),
async void(*copy)(void*));
extern
sync void Wyllie_safe(sh void*linked,sh int n,sh int esize,
async void(*compute)(void*,void*),
async void*(*next)(void*),
async void(*up)(void*,void*),
async void(*copy)(void*));


/*:9*/
#line 99 "ranking.web"


/*:3*/
#line 383 "ranking.web"


/*:14*//*17:*/
#line 421 "ranking.web"

sync void link_up(sh LIST list[],pr void*element)
{
list[ME].element= element;
}

sync void list_make(sh LIST list[],sh int n,
async void*(*next)(void*),
async void(*up)(void*,void*))
{
sh int p= groupsize();
pr LIST*e;

farm{
ppar_item(e,n,list){
e->next= (LIST*)(*next)(e->element);
e->pred= NULL;
up(e->element,e);
e->rank= 0;
}
}
farm{
ppar_item(e,n,list)
if(e->next!=NULL){
e->succ= (LIST*)(*next)(e->next);
e->succ->pred= e;
}else e->succ= NULL;
}
}

sync void list_restore(sh LIST list[],sh int n,
async void(*up)(void*,void*))
{
sh int p= groupsize();
pr int i;

farm{
ppar_array(i,n)
if(list[i].succ!=NULL)
up(list[i].element,list[i].succ->element);
else up(list[i].element,NULL);
}
}

/*:17*//*18:*/
#line 468 "ranking.web"

sync void list_copy(sh LIST slist[],sh int n,sh LIST tlist[])
{
sh int p= groupsize();
pr int i;

farm ppar_array(i,n){
tlist[i].element= slist[i].element;
tlist[i].rank= slist[i].rank;
if(slist[i].succ!=NULL)tlist[i].succ= tlist+(slist[i].succ-slist);
else tlist[i].succ= NULL;
if(slist[i].pred!=NULL)tlist[i].pred= tlist+(slist[i].pred-slist);
else tlist[i].pred= NULL;
}
}

/*:18*//*19:*/
#line 487 "ranking.web"

sync void list_move(sh LIST slist[],sh int n,sh LIST tlist[],
async void(*up)(void*,void*))
{
sh int p= groupsize();
pr int i;

list_copy(slist,n,tlist);
farm ppar_array(i,n)up(ELT(tlist,i),tlist+i);
}

/*:19*//*20:*/
#line 512 "ranking.web"


async void serial_add(LIST*x,LIST*y,LIST*z)
{

x->serial= y->serial+z->serial;
}

sync void lists_move(sh LIST*lists[],sh int n[],sh int k,
sh LIST list[],sh int nn,
async void(*up)(void*,void*))
{
sh int p= groupsize();
pr int i;
pr LIST*si,*sl;
pr LIST*listss;
sh int*ns,*segstart;
sh int kk;

segstart= (int*)shalloc(nn*sizeof(int));
ns= (int*)shalloc(k*sizeof(int));

ppar_array(i,nn){
segstart[i]= 0;
list[i].serial= 1;
}

prefix_add(n,k,ns,0);
ppar_array(i,k-1){
segstart[ns[i]]= 1;
list[ns[i]].serial= 0;
list[ns[i]].last= lists[i+1];
}
seq{
segstart[0]= 1;
list[0].serial= 0;
list[0].last= lists[0];
}
Group_prefix(list,nn,sizeof(LIST),PR3 serial_add,segstart,&kk);

ppar_array(i,nn){
listss= list+(i-list[i].serial);
sl= listss->last;
si= sl+list[i].serial;
if(si->succ!=NULL)
list[i].succ= listss+(si->succ-sl);
else list[i].succ= NULL;
if(si->pred!=NULL)
list[i].pred= listss+(si->pred-sl);
else list[i].pred= NULL;
list[i].rank= si->rank;
list[i].element= si->element;
farm up(si->element,list+i);
}
shallfree();
}

/*:20*//*21:*/
#line 576 "ranking.web"

sync void sublist_move(sh LIST*active[],sh int n,sh LIST list[],
async void(*up)(void*,void*))
{
sh int p= groupsize();
pr int i;

ppar_array(i,n)active[i]->serial= i;
ppar_array(i,n){
list[i].element= active[i]->element;
if(active[i]->succ!=NULL)
list[i].succ= list+active[i]->succ->serial;
else list[i].succ= NULL;
if(active[i]->pred!=NULL)
list[i].pred= list+active[i]->pred->serial;
else list[i].pred= NULL;
list[i].rank= active[i]->rank;
farm up(active[i]->element,list+i);

}
}

/*:21*//*22:*/
#line 607 "ranking.web"

sync int list_findends(sh LIST list[],sh int n,
sh LIST*heads[],sh LIST*tails[])
{
sh int p= groupsize();
pr int i;
sh int sublsts;

farm
ppar_array(i,n)
if(list[i].pred==NULL)list[i].serial= 1;else list[i].serial= 0;
Prefix(list,n,sizeof(LIST),PR3 serial_add);
farm
ppar_array(i,n)
if(list[i].pred==NULL)heads[list[i].serial-1]= list+i;

farm
ppar_array(i,n)
if(list[i].succ==NULL)list[i].serial= 1;else list[i].serial= 0;
Prefix(list,n,sizeof(LIST),PR3 serial_add);
farm
ppar_array(i,n)
if(list[i].succ==NULL)tails[list[i].serial-1]= list+i;
sublsts= list[n-1].serial;
return sublsts;
}

/*:22*//*23:*/
#line 638 "ranking.web"

sync void list_splice(sh LIST*heads[],sh LIST*tails[],sh int k)
{
sh int p= groupsize();
pr int i;

ppar_array(i,k-1){
tails[i]->succ= heads[i+1];
tails[i]->succ->pred= tails[i];

}
}

/*:23*//*24:*/
#line 656 "ranking.web"

sync void list_setlink(sh LIST list[],sh int n,sh LIST*item)
{
sh int p= groupsize();
pr int i;

farm ppar_array(i,n)list[i].last= item;
}

/*:24*//*25:*/
#line 679 "ranking.web"

sync void list_rankorder(sh LIST list[],sh int n,
async void(*up)(void*,void*))
{
sh int p= groupsize();
sh void**e;
pr int i;

e= (void**)shalloc(n*sizeof(void*));

ppar_array(i,n)e[list[i].rank]= list[i].element;
farm{
ppar_array(i,n){
list[i].element= e[i];
list[i].rank= i;
list[i].succ= list+i+1;
list[i].pred= list+i-1;
up(ELT(list,i),list+i);
}
}
seq{
list[0].pred= NULL;
list[n-1].succ= NULL;
}
shallfree();
}

sync void list_revorder(sh LIST list[],sh int n,
async void(*up)(void*,void*))
{
sh int p= groupsize();
sh void**e;
pr int i;

e= (void**)shalloc(n*sizeof(void*));

ppar_array(i,n)e[n-1-list[i].rank]= list[i].element;
farm{
ppar_array(i,n){
list[i].element= e[i];
list[i].rank= n-1-i;
list[i].succ= list+(i+1);
list[i].pred= list+(i-1);
up(ELT(list,i),list+i);
}
}
seq{
list[0].pred= NULL;
list[n-1].succ= NULL;
}
shallfree();
}

/*:25*//*27:*/
#line 739 "ranking.web"

sync void list_reverse(sh LIST list[],sh int n)
{
sh int p= groupsize();
pr int i;
pr LIST*e,*next;

par_item(e,n,list){
next= e->succ;
e->succ= e->pred;
e->pred= next;
e->rank= n-1-e->rank;
}
}


/*:27*//*30:*/
#line 854 "ranking.web"

async void seq_rank(LIST list[],int n)
{
LIST*tail,*head,*e;
int r;

for(tail= list;tail<list+n;tail++){
if(tail->succ==NULL){

e= tail;r= e->rank= 0;
while(e->pred!=NULL){
e= e->pred;
e->rank= ++r;
}

head= e;
while(e->succ!=NULL){
e->last= head;
e= e->succ;
}
tail->last= head;
}
}
}

async void seq_rank_sub(LIST*active[],int n)
{
LIST*tail,*head,*e;
int i;
int r;

for(i= 0;i<n;i++){
tail= active[i];
if(tail->succ==NULL){

e= tail;r= e->rank= 0;
while(e->pred!=NULL){
e= e->pred;
e->rank= ++r;
}

head= e;
while(e->succ!=NULL){
e->last= head;
e= e->succ;
}
}
}
}

/*:30*//*32:*/
#line 970 "ranking.web"

#define WYLLIE 2
sync void list_rank(sh LIST list[],sh int n)
{
sh int p= groupsize();

if(p<=4)seq seq_rank(list,n);
else if(n<(p<<WYLLIE))wyllie(list,n);
else AM_rank(list,n);
}


/*:32*//*33:*/
#line 1033 "ranking.web"

sync void wyllie(sh LIST list[],sh int n)
{
sh int p= groupsize();
sh int nn;
pr LIST*e;



farm ppar_item(e,n,list){
if(e->succ!=NULL){
e->rank= 1;
e->next= e->succ;
}else{
e->rank= 0;
e->next= e;
}
}


nn= n;
while(nn>0){
ppar_item(e,n,list){
e->rank+= e->next->rank;
e->next= e->next->next;
}
nn= nn>>1;
}


farm ppar_item(e,n,list)if(e->pred==NULL)e->next->last= e;
farm ppar_item(e,n,list)e->last= e->next->last;
}

sync void wyllie_sub(sh LIST*active[],sh int n)
{
sh int p= groupsize();
sh int nn;
pr int i;
pr LIST*e;

nn= n;
while(nn>0){
ppar_array(i,n){
e= active[i];
e->rank+= e->next->rank;
e->next= e->next->next;
}
nn= nn>>1;
}
}

/*:33*//*35:*/
#line 1149 "ranking.web"

#define KRS 16

sync void krs_pairoff(sh LIST list[],sh LIST*active[],
sh bool deleted[],pr int block,pr int n)
{
sh int p= groupsize();
sh int blocks;
pr int blockstart,blockend;
pr myblocks;
pr int i,k;
pr LIST*e;

#ifdef TESTING
seq pprintf("Pairoff %d items with %d processors, block %d\n",
n,p,block);
#endif
if(p==1)/*36:*/
#line 1177 "ranking.web"

farm{
blockend= n+block;
for(i= block;i<blockend;i++){
e= active[i];
if(e->status==PAD_neutral&&e->succ->status==PAD_neutral)
/*39:*/
#line 1249 "ranking.web"

{
deleted[e->succ->serial]= TRUE;
e->succ->status= PAD_marked;
e->status= PAD_marked;
}

/*:39*/
#line 1183 "ranking.web"

}
}

/*:36*/
#line 1166 "ranking.web"

else{
/*37:*/
#line 1192 "ranking.web"

myblocks= 0;
blockend= block;

ppar_arrayseg(i,block,n)farm{
blockstart= blockend;blockend= blockend+p;
e= active[i];
if(e->status==PAD_neutral){
k= e->succ->serial;
if(e->succ->status==PAD_marked)e->status= PAD_marked;
else if(k<blockstart||k>=blockend)
/*39:*/
#line 1249 "ranking.web"

{
deleted[e->succ->serial]= TRUE;
e->succ->status= PAD_marked;
e->status= PAD_marked;
}

/*:39*/
#line 1203 "ranking.web"

}
myblocks++;
}
proc(0)blocks= myblocks;


/*:37*/
#line 1168 "ranking.web"

/*38:*/
#line 1220 "ranking.web"

if(blocks>=p>>1)

farm{
ppar_array(k,blocks){
blockstart= k*p+block;blockend= blockstart+p;
if(blockend>n)blockend= n;
for(i= blockstart;i<blockend;i++){
e= active[i];
if(e->status==PAD_neutral&&e->succ->status==PAD_neutral)
/*39:*/
#line 1249 "ranking.web"

{
deleted[e->succ->serial]= TRUE;
e->succ->status= PAD_marked;
e->status= PAD_marked;
}

/*:39*/
#line 1230 "ranking.web"
;
}
}
}else{

fork(blocks;MY= ME%blocks;ME= ME/blocks){
blockstart= MY*p;
if(MY==blocks-1)n= n-blockstart;else n= p;
if(ME<n>>1)
krs_pairoff(list,active,deleted,block+blockstart,n);
}
}

/*:38*/
#line 1169 "ranking.web"

}
}

/*:35*//*40:*/
#line 1273 "ranking.web"

sync void krs_rank_rec(sh LIST list[],sh LIST*active[],
sh bool independent[],sh int index[],
sh int n,sh int nf)
{
sh int p= groupsize();
sh int split[2];
pr int i;
pr LIST*e;

#ifdef TESTING
seq pprintf("Next reduction %d %d\n",n,nf);
#endif
if(n>nf){
/*41:*/
#line 1322 "ranking.web"

farm ppar_array(i,n){
independent[i]= FALSE;
e= active[i];
e->serial= i;
if(e->succ==NULL)e->status= PAD_marked;else e->status= PAD_neutral;
}

/*:41*/
#line 1287 "ranking.web"

krs_pairoff(list,active,independent,0,n);
/*54:*/
#line 1662 "ranking.web"

farm ppar_array(i,n)index[i]= 1;
colorprefix_add(index,n,independent,2,split);
ppar_array(i,n){
e= active[i];
if(independent[i])active[index[i]-1]= e;
else active[n+index[i]-1]= e;
}

/*:54*/
#line 1289 "ranking.web"

/*55:*/
#line 1676 "ranking.web"

farm{

ppar_array(i,split[1]){
e= active[i];

e->pred->succ= e->succ;
e->succ->pred= e->pred;
e->pred->rank+= e->rank;
}
}

/*:55*/
#line 1290 "ranking.web"

krs_rank_rec(list,active+n,independent,index,split[0],nf);
/*56:*/
#line 1695 "ranking.web"

farm{
ppar_array(i,split[1]){
e= active[i];
e->succ->pred= e;
e->pred->succ= e;


e->rank+= e->succ->rank;
}
}

/*:56*/
#line 1292 "ranking.web"

}else{
/*57:*/
#line 1709 "ranking.web"

ppar_array(i,n)
if(active[i]->succ!=NULL)
active[i]->next= active[i]->succ;else active[i]->next= active[i];


/*:57*/
#line 1294 "ranking.web"

wyllie_sub(active,n);
}
}

sync void krs_rank(sh LIST list[],sh int n)
{
sh bool*deleted;
sh int*index;
sh LIST**active;
pr LIST*e;
pr int i;

deleted= (bool*)shalloc(n*sizeof(bool));
index= (int*)shalloc(n*sizeof(int));
active= (LIST**)shalloc(5*n*sizeof(LIST*));

/*53:*/
#line 1647 "ranking.web"

par_array(i,n){
e= list+i;
if(e->succ!=NULL)e->rank= 1;else e->rank= 0;
active[i]= e;
}

/*:53*/
#line 1311 "ranking.web"

krs_rank_rec(list,active,deleted,index,n,KRS*groupsize());
shallfree();
}

/*:40*//*42:*/
#line 1352 "ranking.web"

sync void KRS_pairoff(sh LIST list[],sh LIST*active[],
pr int block,pr int n)
{
sh int p= groupsize();
sh int blocks;
pr int blockstart,blockend;
pr myblocks;
pr int i,k;
pr LIST*e;

#ifdef TESTING
seq pprintf("Pairoff %d items with %d processors, block %d\n",
n,p,block);
#endif
if(p==1)/*43:*/
#line 1377 "ranking.web"

farm{
blockend= n+block;
for(i= block;i<blockend;i++){
e= active[i];
if(e->status==PAD_neutral)
/*47:*/
#line 1484 "ranking.web"

{
e->next->status= PAD_removed;

e->rank+= e->next->rank;
e->next= e->next->next;

e->status= PAD_marked;
}

/*:47*/
#line 1383 "ranking.web"

}
}

/*:43*/
#line 1367 "ranking.web"

else{
/*44:*/
#line 1394 "ranking.web"

myblocks= 0;
blockend= block;

ppar_arrayseg(i,block,n){
blockstart= blockend;blockend= blockend+p;
e= active[i];
if(e->status==PAD_neutral){
e->status= PAD_blocked;
farm
if(e->next->status!=PAD_blocked)/*47:*/
#line 1484 "ranking.web"

{
e->next->status= PAD_removed;

e->rank+= e->next->rank;
e->next= e->next->next;

e->status= PAD_marked;
}

/*:47*/
#line 1404 "ranking.web"

else e->status= PAD_neutral;
}
myblocks++;
}

proc(0)blocks= myblocks;

/*:44*/
#line 1369 "ranking.web"

/*45:*/
#line 1414 "ranking.web"

if(blocks>=p>>1)

farm{
ppar_array(k,blocks){
blockstart= k*p+block;blockend= blockstart+p;
if(blockend>n)blockend= n;
for(i= blockstart;i<blockend;i++){
e= active[i];
if(e->status==PAD_neutral)/*47:*/
#line 1484 "ranking.web"

{
e->next->status= PAD_removed;

e->rank+= e->next->rank;
e->next= e->next->next;

e->status= PAD_marked;
}

/*:47*/
#line 1423 "ranking.web"

}
}
}else{

fork(blocks;MY= ME%blocks;ME= ME/blocks){
blockstart= MY*p;
if(MY==blocks-1)n= n-blockstart;else n= p;
if(ME<n>>1)
KRS_pairoff(list,active,block+blockstart,n);
}
}

/*:45*/
#line 1370 "ranking.web"

}
}

/*:42*//*46:*/
#line 1442 "ranking.web"

sync void KRS_rank_rec(sh LIST list[],sh LIST*active[],
sh bool deleted[],sh int index[],
sh int n,sh int nf)
{
sh int p= groupsize();
sh int split[2];
pr int i;
pr LIST*e;

#ifdef TESTING
seq pprintf("Next reduction %d %d\n",n,nf);
#endif
if(n>nf){
/*48:*/
#line 1496 "ranking.web"

farm ppar_array(i,n){
e= active[i];
if(e->next->next==e->next)
e->status= PAD_marked;else e->status= PAD_neutral;
}

/*:48*/
#line 1456 "ranking.web"

KRS_pairoff(list,active,0,n);
/*51:*/
#line 1539 "ranking.web"

farm ppar_array(i,n){
index[i]= 1;
e= active[i];
if(e->status==PAD_removed)
deleted[i]= TRUE;else deleted[i]= FALSE;
}
colorprefix_add(index,n,deleted,2,split);
farm ppar_array(i,n){
e= active[i];
if(deleted[i])active[index[i]-1]= e;
else active[n+index[i]-1]= e;
}

/*:51*/
#line 1458 "ranking.web"

KRS_rank_rec(list,active+n,deleted,index,split[0],nf);
/*49:*/
#line 1509 "ranking.web"

farm ppar_array(i,split[1]){
e= active[i];
e->rank+= e->next->rank;
}

/*:49*/
#line 1460 "ranking.web"

}else wyllie_sub(active,n);
}

sync void KRS_rank(sh LIST list[],sh int n)
{
sh bool*deleted;
sh int*index;
sh LIST**active;
pr LIST*e;
pr int i;

deleted= (bool*)shalloc(n*sizeof(bool));
index= (int*)shalloc(n*sizeof(int));
active= (LIST**)shalloc(5*n*sizeof(LIST*));

/*50:*/
#line 1517 "ranking.web"

par_array(i,n){
e= list+i;
if(e->succ!=NULL){
e->rank= 1;
e->next= e->succ;
}else{
e->rank= 0;
e->next= e;
}
active[i]= e;
}

/*:50*/
#line 1476 "ranking.web"

KRS_rank_rec(list,active,deleted,index,n,KRS*groupsize());
shallfree();
}

/*:46*//*52:*/
#line 1596 "ranking.web"

#define CV 4

sync void cv_rank_rec(sh LIST list[],sh LIST*active[],sh int independent[],
sh int index[],sh int n,sh int nf)
{
sh int p= groupsize();
sh int split[2];

pr int i;
pr LIST*e;

#ifdef TESTING
seq pprintf("Next reduction %d %d\n",n,nf);
#endif
if(n>nf){
ind_set(active,independent,n);
/*54:*/
#line 1662 "ranking.web"

farm ppar_array(i,n)index[i]= 1;
colorprefix_add(index,n,independent,2,split);
ppar_array(i,n){
e= active[i];
if(independent[i])active[index[i]-1]= e;
else active[n+index[i]-1]= e;
}

/*:54*/
#line 1613 "ranking.web"

/*55:*/
#line 1676 "ranking.web"

farm{

ppar_array(i,split[1]){
e= active[i];

e->pred->succ= e->succ;
e->succ->pred= e->pred;
e->pred->rank+= e->rank;
}
}

/*:55*/
#line 1614 "ranking.web"


cv_rank_rec(list,active+n,independent,index,split[0],nf);
/*56:*/
#line 1695 "ranking.web"

farm{
ppar_array(i,split[1]){
e= active[i];
e->succ->pred= e;
e->pred->succ= e;


e->rank+= e->succ->rank;
}
}

/*:56*/
#line 1617 "ranking.web"

}else{

/*57:*/
#line 1709 "ranking.web"

ppar_array(i,n)
if(active[i]->succ!=NULL)
active[i]->next= active[i]->succ;else active[i]->next= active[i];


/*:57*/
#line 1620 "ranking.web"

wyllie_sub(active,n);
}

}

sync void cv_rank(sh LIST list[],sh int n)
{
sh int nf;
sh int*independent,*index;
sh LIST**active;
pr LIST*e;
pr int i;

active= (LIST**)shalloc(5*n*sizeof(LIST*));
index= (int*)shalloc(2*n*sizeof(int));
independent= index+n;

nf= CV*n/ilog2(n);

/*53:*/
#line 1647 "ranking.web"

par_array(i,n){
e= list+i;
if(e->succ!=NULL)e->rank= 1;else e->rank= 0;
active[i]= e;
}

/*:53*/
#line 1640 "ranking.web"

cv_rank_rec(list,active,independent,index,n,nf);
shallfree();
}

/*:52*//*58:*/
#line 1779 "ranking.web"

#define AM 1

sync void am_rank(sh LIST list[],sh int n)
{
sh int p= groupsize();
sh int*index;
sh LIST**active;
pr LIST*e,*es;
pr LIST*top;
pr int i;
pr int phase,lastphase,idle;
pr int rule;
pr int r;

active= (LIST**)shalloc(n*sizeof(LIST*));
index= (int*)shalloc(n*sizeof(int));

/*59:*/
#line 1835 "ranking.web"

farm
ppar_item(e,n,list){
e->last= e->pred;
if(e->succ!=NULL){
e->rank= 1;
e->next= e->succ;
if(e->pred==NULL)e->status= PAD_special;
else e->status= PAD_neutral;
}else{
e->rank= 0;
e->next= e;
e->status= PAD_special;
}
}

/*:59*/
#line 1797 "ranking.web"


phase= 0;lastphase= AM*n;idle= 0;
e= list+ME;
top= NULL;
while(phase<lastphase){
if(e<list+n){
if(e->status==PAD_neutral)e->status= PAD_active;
if(e->status==PAD_active){
farm{
rule= e->next->status==PAD_active||e->last->status==PAD_active;
}
if(rule)ruling_set(e);else/*60:*/
#line 1856 "ranking.web"

{
e->last->next= e->next;
e->next->last= e->last;
r= e->last->rank;
e->last->rank+= e->rank;
e->rank= r;
e->status= PAD_removed;
#ifdef TESTING
pprintf("splice out %d distance %d\n",e-list,e->rank);
#endif
e->next= top;top= e;
}

/*:60*/
#line 1809 "ranking.web"

}
if(e->status==PAD_ruler)/*61:*/
#line 1873 "ranking.web"

{
es= e->next;
if(es->status==PAD_subject){
es->status= PAD_removed;
r= e->rank;
e->rank+= es->rank;
es->rank= r;
es->next->last= e;
e->next= es->next;
#ifdef TESTING
pprintf("remove subject %d by %d distance %d\n",es-list,e-list,e->rank);
#endif
es->next= top;top= es;
}else e->status= PAD_neutral;
}

/*:61*/
#line 1811 "ranking.web"

else e= e+p;
}else idle++;
phase+= p;
}
/*62:*/
#line 1893 "ranking.web"

farm ppar_array(i,n)
if(list[i].status!=PAD_removed)index[i]= 1;else index[i]= 0;
preprefix_add(index,n,index,0);
farm ppar_array(i,n)
if(list[i].status!=PAD_removed)active[index[i]]= list+i;

/*:62*/
#line 1816 "ranking.web"

#ifdef TESTING
pprintf("Remaining %d of %d; idle %d\n",index[n-1]+1,n,idle);
#endif
wyllie_sub(active,index[n-1]+1);

/*63:*/
#line 1905 "ranking.web"

farm
while(top!=NULL){
if(top->last->status!=PAD_removed){
top->rank= top->last->rank-top->rank;
top->status= PAD_neutral;
top= top->next;
}
}

/*:63*/
#line 1822 "ranking.web"

shallfree();
}

/*:58*//*64:*/
#line 1949 "ranking.web"

/*69:*/
#line 2066 "ranking.web"

enum estatus change1[6]= 
{PAD_active,PAD_active,PAD_ruler,PAD_ruler,PAD_removed,PAD_special};

enum estatus change2[6][6]= {

{PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral},

{PAD_ruler,PAD_subject,PAD_ruler,PAD_subject,PAD_ruler,PAD_ruler},

{PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral},

{PAD_ruler,PAD_ruler,PAD_ruler,PAD_subject,PAD_ruler,PAD_ruler},

{PAD_removed,PAD_removed,PAD_removed,PAD_removed,PAD_removed,PAD_removed},

{PAD_special,PAD_special,PAD_special,PAD_special,PAD_special,PAD_special}
};

enum estatus change3[6][6]= {

{PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral},

{PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral,PAD_neutral},

{PAD_subject,PAD_subject,PAD_subject,PAD_subject,PAD_subject,PAD_subject},

{PAD_ruler,PAD_ruler,PAD_ruler,PAD_subject,PAD_ruler,PAD_ruler},

{PAD_removed,PAD_removed,PAD_removed,PAD_removed,PAD_removed,PAD_removed},

{PAD_special,PAD_special,PAD_special,PAD_special,PAD_special,PAD_special}
};

enum estatus change4[6]= 
{PAD_neutral,PAD_neutral,PAD_ruler,PAD_neutral,PAD_neutral,PAD_neutral};

/*:69*/
#line 1950 "ranking.web"

sync void AM_rank(sh LIST list[],sh int n)
{
sh int p= groupsize();
pr LIST*e,*es,*en;
pr LIST*top;
pr int r;

/*65:*/
#line 1970 "ranking.web"

farm
ppar_item(e,n,list){
if(e->succ!=NULL){
e->rank= 1;
e->next= e->succ;
if(e->pred!=NULL){
e->last= e->pred;
e->status= PAD_neutral;
}else{
e->last= e;
e->status= PAD_special;
}
}else{
e->rank= 0;
e->next= e;
e->status= PAD_special;
if(e->pred==NULL)e->last= e;
}
}

/*:65*/
#line 1958 "ranking.web"


e= list+ME;en= e+p;
top= NULL;
while(e<list+n){
/*68:*/
#line 2060 "ranking.web"

e->status= change1[e->status];
e->status= change2[e->status][e->last->status];
e->status= change3[e->status][e->last->status];

/*:68*/
#line 1963 "ranking.web"

farm
if(e->status==PAD_ruler)/*66:*/
#line 2011 "ranking.web"

{
es= e->next;
e->last->next= es;
es->last= e->last;
r= e->last->rank;
e->last->rank+= e->rank;
e->rank= r;

e->next= top;top= e;

if(es->status==PAD_subject){
e= es;
e->status= change4[e->next->status];
}else/*67:*/
#line 2030 "ranking.web"

{
e= en;en+= p;
}

/*:67*/
#line 2025 "ranking.web"

}

/*:66*/
#line 1965 "ranking.web"
else/*67:*/
#line 2030 "ranking.web"

{
e= en;en+= p;
}

/*:67*/
#line 1965 "ranking.web"

}
/*70:*/
#line 2107 "ranking.web"

farm
while(top!=NULL){
if(top->last->status!=PAD_ruler){
top->rank= top->last->rank-top->rank;
top->last= top->last->last;
top->status= PAD_neutral;
top= top->next;
}
}


/*:70*/
#line 1967 "ranking.web"

}

/*:64*//*73:*/
#line 3292 "ranking.web"

sync void list_getrank(sh LIST list[],sh int n,sh int permutation[])
{
sh int p= groupsize();
pr int i;

ppar_array(i,n)permutation[i]= list[i].rank;
}

/*:73*//*74:*/
#line 3309 "ranking.web"

sync void list_rerank(sh LIST*heads[],sh int k,sh int newrank[],
sh LIST list[],sh int n)
{
sh int p= groupsize();
pr int i;

ppar_array(i,k){
heads[i]->rank= newrank[i]-heads[i]->rank;
heads[i]->last= heads[i];
}
ppar_array(i,n)
if(list[i].last!=list+i)
list[i].rank+= list[i].last->rank;
ppar_array(i,k)heads[i]->rank= newrank[i];
}

/*:74*//*75:*/
#line 3331 "ranking.web"

sync void permute_list(sh int permutation[],sh int n,sh LIST list[],
async void(*up)(void*,void*))
{
sh int p= groupsize();
sh void**e;
pr int i;

e= (void**)shalloc(n*sizeof(void*));
farm
ppar_array(i,n)e[permutation[i]]= ELT(list,i);
farm
ppar_array(i,n){
list[i].element= e[i];
list[i].rank= i;
list[i].succ= list+(i+1);
list[i].pred= list+(i-1);
up(ELT(list,i),list+i);
}
seq{
list[0].pred= NULL;
list[n-1].succ= NULL;
}
shallfree();
}

/*:75*//*76:*/
#line 3363 "ranking.web"

sync void force_list(sh int cycle[],sh int n,
sh LIST list[],sh LIST*head)
{
sh int p= groupsize();
pr int i;

ppar_array(i,n-1){
list[cycle[i]].succ= list+cycle[i+1];
list[cycle[i+1]].pred= list+cycle[i];
}
seq{
list[cycle[n-1]].succ= list+cycle[0];
list[cycle[0]].pred= list+cycle[n-1];

head->pred->succ= NULL;
head->pred= NULL;
}
}

/*:76*//*77:*/
#line 3390 "ranking.web"

sync void force_sublist(sh LIST*sublist[],sh int n,sh LIST list[],
async void(*up)(void*,void*))
{
sh int p= groupsize();
pr int i;

farm
ppar_array(i,n){
list[i].succ= list+(i+1);
list[i].pred= list+(i-1);
list[i].rank= n-1-i;
list[i].element= sublist[i]->element;
up(sublist[i]->element,list+i);
}
seq{
list[0].pred= NULL;
list[n-1].succ= NULL;
}
}

/*:77*//*78:*/
#line 3415 "ranking.web"

sync void force_seqlist(sh LIST list[],sh const int n)
{
sh int p= groupsize();
pr int i;

farm
ppar_array(i,n-1){
list[i].succ= list+(i+1);
list[i+1].pred= list+i;
}
seq{
list[n-1].succ= NULL;
list[0].pred= NULL;
}
}

/*:78*//*79:*/
#line 3440 "ranking.web"

sync void force_meshlist(sh LIST list[],sh int n)
{
sh int p= groupsize();
pr int i;

ppar_array(i,n){
list[i].succ= list+(i+p);
list[i].pred= NULL;
}
i= i-p;
if(ME<p-1)list[i].succ= list+(ME+1);else list[i].succ= NULL;
ppar_array(i,n)
if(list[i].succ!=NULL)list[i].succ->pred= list+i;
}

/*:79*//*80:*/
#line 3460 "ranking.web"

async void seq_random_cycle(pr int cycle[],pr int n)
{
int i,j,k;

for(i= 0;i<n;i++)cycle[i]= i;
srand(666);k= 0;i= 0;
while(k<n-1){
j= rand()%(n-1-k);
if(j<0)j= j+n-1-k;
j= j+k+1;
cycle[k]= cycle[j];
cycle[j]= cycle[k+1];
k++;
}
cycle[n-1]= 0;
}

sync void force_randomlist(sh LIST list[],sh int n,sh LIST*head)
{
sh int p= groupsize();
sh int*cycle;
pr int i,j,k;

cycle= (int*)shalloc(n*sizeof(int));
seq seq_random_cycle(cycle,n);
force_list(cycle,n,list,head);
shallfree();
}

/*:80*//*81:*/
#line 3492 "ranking.web"

sync void apply_listfunc(sh LIST list[],sh int n,async void(*f)(void*))
{
sh int p= groupsize();
pr int i;

farm ppar_array(i,n)f(ELT(list,i));
}

/*:81*//*83:*/
#line 3534 "ranking.web"

sync void jump_init(sh LIST list[],sh int n,async void(*init)(void*))
{
sh int p= groupsize();
pr int i;

farm ppar_array(i,n){
list[i].next= list[i].succ;
init(ELT(list,i));
}
}

sync void jump(sh LIST list[],sh int n,async void(*compute)(void*,void*))
{
sh int p= groupsize();
pr int i;

farm ppar_array(i,n){
if(list[i].next!=NULL){
compute(ELT(list,i),list[i].next->element);
list[i].next= list[i].next->next;
}
}
}

sync void jump_safe(sh LIST list[],sh int n,
async void(*compute)(void*,void*),
async void(*copy)(void*))
{
sh int p= groupsize();
pr int i;

farm ppar_array(i,n){
if(list[i].next!=NULL){
compute(ELT(list,i),list[i].next->element);
list[i].next= list[i].next->next;
}
}
apply_listfunc(list,n,copy);
}

/*:83*//*84:*/
#line 3584 "ranking.web"

sync void Jump(sh void*linked,sh int n,sh int esize,
async void(*compute)(void*,void*),
async void*(*next)(void*),
async void(*up)(void*,void*))
{
sh int p= groupsize();
pr void*e,*ne;
pr int i;

farm ppar_array(i,n){
e= (void*)((char*)linked+i*esize);
ne= next(e);
if(ne!=NULL){
compute(e,ne);
up(e,next(ne));
}
}
}

sync void Wyllie(sh void*linked,sh int n,sh int esize,
async void(*compute)(void*,void*),
async void*(*next)(void*),
async void(*up)(void*,void*))
{
sh int nn;

nn= n;
while(nn>1){
Jump(linked,n,esize,compute,next,up);
nn= nn>>1;
}
}

sync void Jump_safe(sh void*linked,sh int n,sh int esize,
async void(*compute)(void*,void*),
async void*(*next)(void*),
async void(*up)(void*,void*),
async void(*copy)(void*))
{
sh int p= groupsize();
pr int i;

Jump(linked,n,esize,compute,next,up);
farm ppar_array(i,n)copy((char*)linked+i*esize);
}

sync void Wyllie_safe(sh void*linked,sh int n,sh int esize,
async void(*compute)(void*,void*),
async void*(*next)(void*),
async void(*up)(void*,void*),
async void(*copy)(void*))
{
sh int nn;

nn= n;
while(nn>1){
Jump_safe(linked,n,esize,compute,next,up,copy);
nn= nn>>1;
}
}

/*:84*//*85:*/
#line 3668 "ranking.web"

#define C_LOGSTAR 4 

int ctab[6][6]= {
{1,2,1,1,1,1},
{2,0,0,0,0,0},
{1,0,0,0,0,0},
{1,0,0,0,0,0},
{1,0,0,0,0,0},
{1,0,0,0,0,0}
};

sync void recolor(sh LIST*active[],sh int n)

{
sh int p= groupsize();
pr int i;
pr LIST*e;
pr int k;
pr int b;

ppar_array(i,n){
e= active[i];

if(e->succ==NULL)e->util= e->color&1;
else{
/*86:*/
#line 3797 "ranking.web"

{
k= e->color^e->succ->color;
k= (~(k-1))&k;
k= ilog2(k);
b= (e->color>>k)&1;
}

/*:86*/
#line 3694 "ranking.web"

e->util= (k<<1)+b;

}
}
farm ppar_array(i,n){
e= active[i];
e->color= e->util;
}
}

sync void color3(sh LIST*active[],sh int n)
{
sh int p= groupsize();
sh int k;
pr int i;
pr int cp,cs;
pr LIST*e;

for(k= 3;k<6;k++)farm{

ppar_array(i,n){
e= active[i];
if(e->color==k){
if(e->pred==NULL)cp= 2;else cp= e->pred->color;
if(e->succ==NULL)cs= 2;else cs= e->succ->color;
e->color= ctab[cp][cs];
}
}
}
}

sync void color_star(sh LIST*active[],sh int n)

{
sh int p= groupsize();
sh int k;
pr int i;

ppar_array(i,n)active[i]->color= i;

for(k= 0;k<C_LOGSTAR;k++)recolor(active,n);
color3(active,n);
}

sync void color(sh LIST*active[],sh int n)

{
sh int p= groupsize();
pr int i,s,k;
pr int cp,cs;
pr LIST*e;
sh int*colorindex,*color_rank,*sortcolor;

colorindex= (int*)shalloc(3*n*sizeof(int));
color_rank= colorindex+n;
sortcolor= color_rank+n;

ppar_array(i,n)active[i]->color= i;

recolor(active,n);
ppar_array(i,n)colorindex[i]= active[i]->color;
smallperm(colorindex,n,n,color_rank);

ppar_array(i,n)sortcolor[color_rank[i]]= colorindex[i];
ppar_array(i,n-1)
if(sortcolor[i]!=sortcolor[i+1])
colorindex[i+1]= 1;else colorindex[i+1]= 0;
seq colorindex[0]= 0;
prefix_add(colorindex,n,colorindex,0);
ppar_array(i,n-1)
if(sortcolor[i]!=sortcolor[i+1])
colorindex[colorindex[i]]= i+1;
seq colorindex[colorindex[n-1]]= n;
ppar_array(i,n)sortcolor[color_rank[i]]= i;

k= 0;s= 0;
do{
i= s+ME;s= colorindex[k];
farm{
while(i<s){

e= active[sortcolor[i]];

if(e->pred==NULL)cp= 2;else
cp= min(2,e->pred->color);
if(e->succ==NULL)cs= 2;else
cs= min(2,e->succ->color);
e->color= ctab[cp][cs];
i= i+p;
}
}
k++;
}while(s<n);

shallfree();
}

/*:85*//*87:*/
#line 3808 "ranking.web"

sync void ind_set(sh LIST*active[],sh int independent[],sh int n)
{
sh int p= groupsize();
pr int i;
pr LIST*e;

color_star(active,n);
farm
ppar_array(i,n){
e= active[i];
if(e->pred!=NULL&&e->succ!=NULL)
independent[i]= ((e->color<e->pred->color)&&
(e->color<e->succ->color));
else independent[i]= FALSE;
}
}

/*:87*//*88:*/
#line 3834 "ranking.web"

sync void ruling_set(pr LIST*e)
{
pr int k;
pr int b;



if(e->next->status!=PAD_active){
e->color= ME&1;
e->status= PAD_subject;
}else{
e->color= ME;

/*90:*/
#line 3875 "ranking.web"

{
k= e->color^e->next->color;
k= (~(k-1))&k;
k= ilog2(k);
b= (e->color>>k)&1;
}

/*:90*/
#line 3848 "ranking.web"

e->color= (k<<1)+b;


/*90:*/
#line 3875 "ranking.web"

{
k= e->color^e->next->color;
k= (~(k-1))&k;
k= ilog2(k);
b= (e->color>>k)&1;
}

/*:90*/
#line 3852 "ranking.web"

e->color= (k<<1)+b;

farm
if(e->last->status!=PAD_active)e->status= PAD_ruler;else
if(e->last->color>e->color&&e->next->color>e->color)
e->status= PAD_ruler;
else e->status= PAD_subject;
}
}

/*:88*//*89:*/
#line 3867 "ranking.web"

sync void simple_ruling_set(pr LIST*e)
{
if(e->last->status!=PAD_active)e->status= PAD_ruler;
else e->status= PAD_subject;
}

/*:89*/
