/*11:*/
#line 265 "trees.web"

#ifndef PADtree
#define PADtree
/*4:*/
#line 133 "trees.web"

typedef struct tree_node{
int node_id;
int capacity;
int degree;
struct tree_edge*firstedge,*lastedge;
struct tree_node*parent;
struct tree_node*next;
struct tree_node*breadthnext;
struct tree_node*children[2];
struct tree_node*sibling;
int child_no;

int level;
int height;
int pre,post,trav;
int desc;
int l,r;
int serial;
void*content;
}TREE_NODE;



typedef struct tree_edge{
int edge_id;
int weight;
struct tree_node*tail,*head;
struct tree_edge*rev;
struct tree_edge*eulernext;
struct tree_edge*prev,*next;
int serial;

void*content;
}TREE_EDGE;



typedef struct tree{
int n,m;
struct tree_node*nodes;
struct tree_node*endnode;
struct tree_edge*edges;
struct tree_edge*endedge;
struct tree_node*root;
}TREE;



/*:4*/
#line 268 "trees.web"

/*9:*/
#line 225 "trees.web"

#define par_edges(e,T) for(e= (T)->edges+ME;e<(T)->endedge;e+= parentgroupsize())
#define par_nodes(v,T) for(v= (T)->nodes+ME;v<(T)->endnode;v+= parentgroupsize())
#define par_adjacent(e,v) \
  for(e= (v)->firstedge;e<(v)->firstedge+(v)->degree;e+= parentgroupsize())

/*:9*/
#line 269 "trees.web"

/*10:*/
#line 233 "trees.web"

#define tree_n(t) ((t)->n)
#define tree_e(t) ((t)->m)



#define node_id(v) ((v)->node_id)
#define node_degree(v) ((v)->degree)
#define node_level(v) ((v)->level)
#define node_height(v) ((v)->height)
#define node_post(v) ((v)->post)
#define node_pre(v) ((v)->pre)
#define node_desc(v) ((v)->desc)
#define node_first(v) ((v)->firstedge)
#define node_last(v) ((v)->firstedge+((v)->degree-1))
#define node_content(v) ((v)->content)
#define LEAF(v) ((v)->children[0]==NULL) 
#define NODE(i,t) ((t)->nodes+(i)) 
#define NODE_NO(v,t) ((v)-(t)->nodes) 



#define edge_id(e) ((e)->edge_id)
#define edge_content(e) ((e)->content)


#define DOWN(e) (((e)->head->parent==(e)->tail)) 
#define UP(e) (((e)->tail->parent==(e)->head)) 
#define EDGE(i,t) ((t)->edges+(i)) 
#define EDGE_NO(e,t) ((e)-(t)->edges) 

/*:10*/
#line 270 "trees.web"

/*6:*/
#line 189 "trees.web"

extern sync TREE*tree_alloc(sh int n);
extern sync TREE*tree_make(sh TREE_NODE*nodes,sh int n,
sh TREE_EDGE*edges,sh int m,
sh int root);
extern sync void node_copy(sh TREE*t,sh TREE*nt);
extern sync void edge_copy(sh TREE*t,sh TREE*nt);
extern sync void tree_copy(sh TREE*t,sh TREE*nt);
extern sync void tree_compact(sh TREE*t);
extern sync void mark_subtree(sh TREE*t,sh TREE_NODE*st,sh LIST euler[]);
extern sync TREE*tree_makebin(sh TREE*t,sh int dummynode,sh int dummyedge);

/*:6*//*7:*/
#line 202 "trees.web"

extern sync void tree_smallrev(sh TREE*t);
extern sync void eulertour(sh TREE*t);
extern sync void tree_root(sh TREE*t,sh TREE_NODE*root,sh LIST*eulerlist);
extern sync RANGE*lca_preprocess(sh TREE*t,sh LIST euler[]);
extern async TREE_NODE*lca(pr TREE_NODE*u,pr TREE_NODE*v,
pr RANGE*lcaquery);
extern sync void tree_height(sh TREE*t,sh LIST eulerlist[]);
extern sync void bintree_height(sh TREE*t,sh LIST*eulerlist);
extern
sync void bintree_contract(sh TREE*t,sh LIST*eulerlist,
async void(*rk)(void*,void*,void*),
async void(*rkrt)(void*,void*,void*),
async void(*unrk)(void*,void*,void*));

/*:7*//*8:*/
#line 218 "trees.web"

extern sync TREE*complete_tree(sh int n,sh int degree,sh int children);

/*:8*/
#line 271 "trees.web"

#endif

/*:11*/
