/*12:*/
#line 281 "trees.web"

#include <fork.h>
#include <io.h>
#include <string.h>
#include <math.h>
#include "pad.h"
#include "prefix.h"
#include "list.h"

/*4:*/
#line 133 "trees.web"

typedef struct tree_node{
int node_id;
int capacity;
int degree;
struct tree_edge*firstedge,*lastedge;
struct tree_node*parent;
struct tree_node*next;
struct tree_node*breadthnext;
struct tree_node*children[2];
struct tree_node*sibling;
int child_no;

int level;
int height;
int pre,post,trav;
int desc;
int l,r;
int serial;
void*content;
}TREE_NODE;



typedef struct tree_edge{
int edge_id;
int weight;
struct tree_node*tail,*head;
struct tree_edge*rev;
struct tree_edge*eulernext;
struct tree_edge*prev,*next;
int serial;

void*content;
}TREE_EDGE;



typedef struct tree{
int n,m;
struct tree_node*nodes;
struct tree_node*endnode;
struct tree_edge*edges;
struct tree_edge*endedge;
struct tree_node*root;
}TREE;



/*:4*/
#line 290 "trees.web"

/*9:*/
#line 225 "trees.web"

#define par_edges(e,T) for(e= (T)->edges+ME;e<(T)->endedge;e+= parentgroupsize())
#define par_nodes(v,T) for(v= (T)->nodes+ME;v<(T)->endnode;v+= parentgroupsize())
#define par_adjacent(e,v) \
  for(e= (v)->firstedge;e<(v)->firstedge+(v)->degree;e+= parentgroupsize())

/*:9*/
#line 291 "trees.web"

/*10:*/
#line 233 "trees.web"

#define tree_n(t) ((t)->n)
#define tree_e(t) ((t)->m)



#define node_id(v) ((v)->node_id)
#define node_degree(v) ((v)->degree)
#define node_level(v) ((v)->level)
#define node_height(v) ((v)->height)
#define node_post(v) ((v)->post)
#define node_pre(v) ((v)->pre)
#define node_desc(v) ((v)->desc)
#define node_first(v) ((v)->firstedge)
#define node_last(v) ((v)->firstedge+((v)->degree-1))
#define node_content(v) ((v)->content)
#define LEAF(v) ((v)->children[0]==NULL) 
#define NODE(i,t) ((t)->nodes+(i)) 
#define NODE_NO(v,t) ((v)-(t)->nodes) 



#define edge_id(e) ((e)->edge_id)
#define edge_content(e) ((e)->content)


#define DOWN(e) (((e)->head->parent==(e)->tail)) 
#define UP(e) (((e)->tail->parent==(e)->head)) 
#define EDGE(i,t) ((t)->edges+(i)) 
#define EDGE_NO(e,t) ((e)-(t)->edges) 

/*:10*/
#line 292 "trees.web"

/*6:*/
#line 189 "trees.web"

extern sync TREE*tree_alloc(sh int n);
extern sync TREE*tree_make(sh TREE_NODE*nodes,sh int n,
sh TREE_EDGE*edges,sh int m,
sh int root);
extern sync void node_copy(sh TREE*t,sh TREE*nt);
extern sync void edge_copy(sh TREE*t,sh TREE*nt);
extern sync void tree_copy(sh TREE*t,sh TREE*nt);
extern sync void tree_compact(sh TREE*t);
extern sync void mark_subtree(sh TREE*t,sh TREE_NODE*st,sh LIST euler[]);
extern sync TREE*tree_makebin(sh TREE*t,sh int dummynode,sh int dummyedge);

/*:6*//*7:*/
#line 202 "trees.web"

extern sync void tree_smallrev(sh TREE*t);
extern sync void eulertour(sh TREE*t);
extern sync void tree_root(sh TREE*t,sh TREE_NODE*root,sh LIST*eulerlist);
extern sync RANGE*lca_preprocess(sh TREE*t,sh LIST euler[]);
extern async TREE_NODE*lca(pr TREE_NODE*u,pr TREE_NODE*v,
pr RANGE*lcaquery);
extern sync void tree_height(sh TREE*t,sh LIST eulerlist[]);
extern sync void bintree_height(sh TREE*t,sh LIST*eulerlist);
extern
sync void bintree_contract(sh TREE*t,sh LIST*eulerlist,
async void(*rk)(void*,void*,void*),
async void(*rkrt)(void*,void*,void*),
async void(*unrk)(void*,void*,void*));

/*:7*//*8:*/
#line 218 "trees.web"

extern sync TREE*complete_tree(sh int n,sh int degree,sh int children);

/*:8*/
#line 293 "trees.web"


/*:12*//*13:*/
#line 300 "trees.web"

async TREE_EDGE*edge_next(TREE_EDGE*e,TREE*t)
{
pr TREE_EDGE*ne;

ne= e+1;
if(ne->tail!=e->tail||ne==t->endedge)ne= e->tail->firstedge;
return ne;
}

/*:13*//*14:*/
#line 316 "trees.web"

sync TREE*tree_alloc(sh int n)
{
sh TREE*t;

t= (TREE*)shalloc(sizeof(TREE));


t->n= n;t->m= 2*(n-1);
t->nodes= (TREE_NODE*)shalloc(t->n*sizeof(TREE_NODE));
t->edges= (TREE_EDGE*)shalloc(t->m*sizeof(TREE_EDGE));
t->endnode= t->nodes+t->n;
t->endedge= t->edges+t->m;

return t;
}

/*:14*//*15:*/
#line 336 "trees.web"

sync TREE*tree_make(sh TREE_NODE*nodes,sh int n,sh TREE_EDGE*edges,sh int m,
sh int root)
{
TREE*t;

t= (TREE*)shalloc(sizeof(TREE));
t->n= n;t->m= m;
t->nodes= nodes;
t->endnode= t->nodes+n;
t->edges= edges;
t->endedge= t->edges+m;
t->root= t->nodes+root;

return t;
}

/*:15*//*16:*/
#line 358 "trees.web"

sync void node_copy(sh TREE*t,sh TREE*nt)
{
sh int p= groupsize();
pr TREE_NODE*v,*nv;

Copy_array(t->nodes,nt->nodes,t->n,sizeof(TREE_NODE));
nv= NODE(ME,nt);
par_nodes(v,t){
nv->firstedge= EDGE(EDGE_NO(v->firstedge,t),nt);
nv+= p;
}
}

sync void edge_copy(sh TREE*t,sh TREE*nt)
{
sh int p= groupsize();
pr TREE_EDGE*e,*ne;

ne= EDGE(ME,nt);
par_edges(e,t){
ne->edge_id= e->edge_id;
ne->weight= e->weight;
ne->tail= NODE(NODE_NO(e->tail,t),nt);
ne->head= NODE(NODE_NO(e->head,t),nt);
ne->rev= EDGE(EDGE_NO(e->rev,t),nt);
ne->eulernext= EDGE(EDGE_NO(e->eulernext,t),nt);
ne->next= EDGE(EDGE_NO(e->next,t),nt);
ne->prev= EDGE(EDGE_NO(e->prev,t),nt);
ne->serial= e->serial;
ne->content= e->content;
ne+= p;
}
}

sync void tree_copy(sh TREE*t,sh TREE*nt)
{
pr TREE_NODE*v,*nv;
pr TREE_EDGE*e,*ne;
pr int i;

nt->root= NODE(NODE_NO(t->root,t),nt);
node_copy(t,nt);
edge_copy(t,nt);
}

/*:16*//*17:*/
#line 420 "trees.web"

/*20:*/
#line 501 "trees.web"

async void node_serial(pr TREE_NODE*u,pr TREE_NODE*v,pr TREE_NODE*w)
{
u->serial= v->serial+w->serial;
}

async void edge_serial(pr TREE_EDGE*e,pr TREE_EDGE*f,pr TREE_EDGE*g)
{
e->serial= f->serial+g->serial;
}

/*:20*/
#line 421 "trees.web"

sync void tree_compact(sh TREE*t)
{
pr TREE_EDGE*e;
pr TREE_NODE*u;

/*18:*/
#line 435 "trees.web"

par_edges(e,t)e->serial= 1;
par_edges(e,t){
farm
if(e->rev->tail==NULL||e->rev->head==NULL)e->tail= NULL;


if(e->tail==NULL)e->serial= 0;
else if(e->tail->firstedge==NULL){
e->tail= NULL;
e->serial= 0;
}
if(e->head==NULL){
e->tail= NULL;
e->serial= 0;
}else if(e->head->firstedge==NULL){
e->tail= NULL;
e->serial= 0;
}
}
par_nodes(u,t)if(u->firstedge==NULL)u->serial= 0;else u->serial= 1;

/*:18*/
#line 427 "trees.web"

/*19:*/
#line 464 "trees.web"


Prefix(t->edges,t->m,sizeof(TREE_EDGE),PR3 edge_serial);
par_edges(e,t)e->rev= EDGE((e->rev->serial-1),t);
par_edges(e,t)if(e->tail!=NULL)
memcpy(EDGE(e->serial-1,t),e,sizeof(TREE_EDGE));


t->m= (t->endedge-1)->serial;
t->endedge= EDGE(t->m,t);
Prefix(t->nodes,t->n,sizeof(TREE_NODE),PR3 node_serial);
par_edges(e,t){
farm{
if(e==t->edges||e->tail!=(e-1)->tail)e->tail->firstedge= e;
if((e+1)==t->endedge||e->tail!=(e+1)->tail)e->tail->lastedge= e+1;
}
}
par_edges(e,t){
e->tail= NODE(e->tail->serial-1,t);
e->head= NODE(e->head->serial-1,t);
}
par_nodes(u,t)
if(u->firstedge!=NULL){
u->degree= u->lastedge-u->firstedge;
memcpy(NODE(u->serial-1,t),u,sizeof(TREE_NODE));
}
t->n= (t->endnode-1)->serial;
t->endnode= NODE(t->n,t);


/*:19*/
#line 428 "trees.web"

}

/*:17*//*21:*/
#line 520 "trees.web"

sync void mark_subtree(sh TREE*t,sh TREE_NODE*st,sh LIST euler[])
{
pr int i;

par_arrayseg(i,st->l+1,st->r-st->l)
if(DOWN((TREE_EDGE*)ELT(euler,i)))
((TREE_EDGE*)ELT(euler,i))->head->firstedge= NULL;
}

/*:21*//*22:*/
#line 551 "trees.web"

sync TREE*tree_makebin(sh TREE*t,sh int dummynode,sh int dummyedge)
{
sh TREE*bt;
pr TREE_NODE*v,*par,*sib1,*sib2;
pr TREE_EDGE*e,*edown,*eup;
pr int i,j;

sh int n;
sh int m;
sh TREE_NODE*nodes;
sh TREE_EDGE*edges;

t->root->degree++;
/*23:*/
#line 584 "trees.web"

par_edges(e,t){
e->serial= EDGE_NO(e,t)-EDGE_NO(e->tail->firstedge,t);
if(UP(e))e->tail->serial= e->serial;
}
t->root->serial= -1;
par_edges(e,t){
if(e->serial<e->tail->serial)
e->serial= e->tail->degree+e->serial-e->tail->serial;
else e->serial= e->serial-e->tail->serial;
}

/*:23*/
#line 565 "trees.web"

/*24:*/
#line 607 "trees.web"


par_nodes(v,t){
if(v->degree>2)v->serial= v->degree-2;
else v->serial= v->degree;
}
Prefix(t->nodes,t->n,sizeof(TREE_NODE),PR3 node_serial);
n= (t->endnode-1)->serial;
m= 2*(n-1);
par_nodes(v,t){
if(v->degree>2)v->serial= v->serial-v->degree+2;
else v->serial= v->serial= v->serial-v->degree;
}


/*:24*/
#line 566 "trees.web"


nodes= (TREE_NODE*)shalloc(n*sizeof(TREE_NODE));
edges= (TREE_EDGE*)shalloc(m*sizeof(TREE_EDGE));
/*25:*/
#line 625 "trees.web"

par_array(i,n){
nodes[i].degree= 3;
nodes[i].node_id= dummynode;
nodes[i].capacity= 0;
}
par_nodes(v,t){
nodes[v->serial].node_id= v->node_id;
nodes[v->serial].capacity= v->capacity;
nodes[v->serial].level= v->level;
nodes[v->serial].height= v->height;
nodes[v->serial].pre= v->pre;
nodes[v->serial].post= v->post;
nodes[v->serial].trav= v->trav;
nodes[v->serial].desc= v->desc;
nodes[v->serial].content= v->content;
if(LEAF(v)){

nodes[v->serial].degree= 1;
nodes[v->serial].children[0]= NULL;
nodes[v->serial].children[1]= NULL;
}
if(v->degree==2){

nodes[v->serial+1].degree= 1;
nodes[v->serial+1].children[0]= NULL;
nodes[v->serial+1].children[1]= NULL;
}
}
nodes[t->root->serial].degree= 2;
par_array(i,n)nodes[i].serial= nodes[i].degree;
Prefix(nodes,n,sizeof(TREE_NODE),PR3 node_serial);
par_array(i,n)
nodes[i].firstedge= edges+(nodes[i].serial-nodes[i].degree);

/*:25*/
#line 570 "trees.web"

/*26:*/
#line 661 "trees.web"

par_edges(e,t)farm{
if(e->serial>0){

if(e->serial<e->tail->degree-1){

i= e->tail->serial+e->serial-1;
j= e->head->serial;
par= nodes+i;
sib1= nodes+j;

edown= par->firstedge;
edown->edge_id= e->edge_id;
edown->weight= e->weight;
edown->tail= par;
edown->head= sib1;

eup= sib1->firstedge+(sib1->degree-1);
eup->edge_id= e->rev->edge_id;
eup->weight= e->rev->weight;
eup->tail= sib1;
eup->head= par;

edown->rev= eup;
eup->rev= edown;

edown++;
if(e->serial<e->tail->degree-2){

j= i+1;
sib2= nodes+j;

edown->edge_id= dummyedge;
edown->tail= par;
edown->head= sib2;

eup= sib2->firstedge+(sib2->degree-1);
eup->edge_id= dummyedge;
eup->tail= sib2;
eup->head= par;

edown->rev= eup;
eup->rev= edown;
}else{

j= edge_next(e,t)->head->serial;
sib2= nodes+j;

edown->edge_id= e->edge_id;
edown->weight= e->weight;
edown->tail= par;
edown->head= sib2;

eup= sib2->firstedge+(sib2->degree-1);
eup->edge_id= e->rev->edge_id;
eup->weight= e->rev->weight;
eup->tail= sib2;
eup->head= par;

edown->rev= eup;
eup->rev= edown;
}
}
par->children[0]= sib1;
sib1->child_no= 0;
par->children[1]= sib2;
sib2->child_no= 1;
sib1->parent= par;
sib2->parent= par;
sib1->sibling= sib2;
sib2->sibling= sib1;
}
}

/*:26*/
#line 571 "trees.web"

t->root->degree--;

bt= tree_make(nodes,n,edges,m,NODE_NO(t->root,t));
bt->root->parent= NULL;

return bt;
}

/*:22*//*27:*/
#line 758 "trees.web"

sync void eulertour(sh TREE*t)
{
pr TREE_EDGE*e;

par_edges(e,t)farm e->eulernext= edge_next(e->rev,t);
}

/*:27*//*28:*/
#line 776 "trees.web"

sync void tree_smallrev(sh TREE*t)
{
sh TREE_EDGE***reverse;
pr TREE_NODE*v;
pr TREE_EDGE*e;


reverse= (TREE_EDGE***)shalloc(t->n*sizeof(TREE_EDGE**));

par_nodes(v,t)
reverse[NODE_NO(v,t)]= (TREE_EDGE**)malloc(t->n*sizeof(TREE_EDGE*));
par_edges(e,t)reverse[NODE_NO(e->tail,t)][NODE_NO(e->head,t)]= e;
par_edges(e,t)e->rev= reverse[NODE_NO(e->head,t)][NODE_NO(e->tail,t)];
shallfree();
}

/*:28*//*29:*/
#line 818 "trees.web"

/*30:*/
#line 858 "trees.web"

struct trav_num{
int level;
int pre,post;
int desc;
};

/*:30*/
#line 819 "trees.web"

/*31:*/
#line 870 "trees.web"

async void update_euler(TREE_EDGE*e1,TREE_EDGE*e2)
{
e1->eulernext= e2;
}

async TREE_EDGE*next_euler(TREE_EDGE*e)
{
return e->eulernext;
}

async void trav_upd(pr struct trav_num*x,
pr struct trav_num*y,pr struct trav_num*z)
{
x->level= y->level+z->level;
x->pre= y->pre+z->pre;
x->post= y->post+z->post;
}

/*:31*/
#line 820 "trees.web"

sync void tree_root(sh TREE*t,sh TREE_NODE*root,sh LIST*eulerlist)
{
sh int p= groupsize();

sh LIST*elist;
pr TREE_EDGE*e,*e1,*e2;
sh struct trav_num*trav;
pr int i;

trav= (struct trav_num*)shalloc(t->m*sizeof(struct trav_num));

t->root= root;
node_last(root)->rev->eulernext= NULL;
elist= eulerlist;

par_edges(e,t){

link_up(elist,e);
elist= elist+p;
}
list_make(eulerlist,t->m,FC1(void*)next_euler,PR2 update_euler);

list_rank(eulerlist,t->m);


par_edges(e,t)
if(RANK(e->eulernext)<RANK(e->rev->eulernext))
e->tail->parent= e->head;
root->parent= NULL;

/*32:*/
#line 900 "trees.web"

list_aorder(eulerlist,t->m,PR2 update_euler);
farm
ppar_array(i,t->m){
e= ELT(eulerlist,i);
if(DOWN(e)){

trav[i].level= 1;
trav[i].pre= 1;
trav[i].post= 0;
}else{

trav[i].level= -1;
trav[i].pre= 0;
trav[i].post= 1;
}
}
Prefix(trav,t->m,sizeof(struct trav_num),PR3 trav_upd);
farm
ppar_array(i,t->m){
e= ELT(eulerlist,i);
if(DOWN(e)){

e->head->level= trav[i].level;
e->head->pre= trav[i].pre;
e->head->desc= -trav[i].pre;
}
}
farm
ppar_array(i,t->m){
e= ELT(eulerlist,i);
if(UP(e)){

e->tail->post= trav[i].post-1;
e->tail->desc+= trav[i].pre;
}
}
root->level= 0;
root->pre= 0;
root->post= t->n-1;
root->desc= t->n-1;

/*:32*/
#line 851 "trees.web"

/*33:*/
#line 951 "trees.web"

root->children[0]= ((TREE_EDGE*)ELT(eulerlist,0))->head;
root->child_no= 0;
root->sibling= root;

farm
ppar_array(i,t->m-1){
e1= ELT(eulerlist,i);
e2= ELT(eulerlist,i+1);
if(DOWN(e1))
if(DOWN(e2)){
e1->head->children[0]= e2->head;
e2->head->child_no= 0;
}else{

e1->head->children[0]= NULL;
e1->head->children[1]= NULL;
e1->head->child_no= 0;
e1->head->sibling= e1->head;
}
}
farm
ppar_array(i,t->m-1){
e1= ELT(eulerlist,i);
e2= ELT(eulerlist,i+1);
if(UP(e1))
if(DOWN(e2))e1->tail->sibling= e2->head;
else{
e1->tail->sibling= e2->tail->children[0];
e1->tail->child_no= 1;
e2->tail->children[1]= e1->tail;
}
}
e= ELT(eulerlist,t->m-1);
e->tail->sibling= root->children[0];
root->children[1]= e->tail;

/*:33*/
#line 852 "trees.web"


shallfree();
}

/*:29*//*34:*/
#line 998 "trees.web"

async void seq_dfs(TREE*t,TREE_NODE*root)
{
pr TREE_NODE*u,*v,*top;
pr TREE_EDGE*e;
pr int pre,post;

t->root= root;


for(v= t->nodes;v<t->endnode;v++){
v->lastedge= v->firstedge;
v->level= -1;
v->height= 0;
}


root->parent= NULL;
root->sibling= root;
root->children[0]= NULL;root->children[1]= NULL;
root->child_no= 0;
root->next= NULL;
root->level= 0;
root->pre= 0;

top= root;pre= 0;post= 0;
while(top!=NULL){
u= top;

if(u->lastedge<u->firstedge+u->degree){
v= u->lastedge->head;
if(v->level==-1)/*35:*/
#line 1036 "trees.web"

{

pre++;

v->parent= u;
if(u->children[0]==NULL){
u->children[0]= v;
v->child_no= 0;
}else{
u->children[1]->sibling= v;
if(u->height<1+u->children[1]->height)
u->height= 1+u->children[1]->height;
}
u->children[1]= v;
v->children[0]= NULL;v->children[1]= NULL;
v->level= u->level+1;
v->pre= pre;

v->next= top;top= v;
}

/*:35*/
#line 1029 "trees.web"

u->lastedge++;
}else/*36:*/
#line 1059 "trees.web"

{
u->post= post;post++;
u->desc= pre-u->pre;
if(u->children[0]!=NULL){
u->children[1]->sibling= u->children[0];
u->children[1]->child_no= 1;
if(u->height<1+u->children[1]->height)
u->height= 1+u->children[1]->height;
}
top= top->next;
}

/*:36*/
#line 1031 "trees.web"

}
}

/*:34*//*37:*/
#line 1123 "trees.web"

/*39:*/
#line 1167 "trees.web"

struct lca_elt{
int level;
TREE_NODE*v;
};

async void lca_upd(pr struct lca_elt*lca,
pr struct lca_elt*lca1,pr struct lca_elt*lca2)
{
if(lca1->level<=lca2->level){
lca->level= lca1->level;
lca->v= lca1->v;
}else{
lca->level= lca2->level;
lca->v= lca2->v;
}
}

/*:39*/
#line 1124 "trees.web"

sync RANGE*lca_preprocess(sh TREE*t,sh LIST euler[])
{
sh int p= groupsize();
pr int i;
pr TREE_EDGE*e;
sh struct lca_elt*edges;
sh RANGE*lca_query;

lca_query= (RANGE*)shalloc(sizeof(RANGE));
range_alloc(t->m,sizeof(struct lca_elt),lca_query);

edges= (struct lca_elt*)lca_query->pre[0];
farm
ppar_array(i,t->m){
e= (TREE_EDGE*)ELT(euler,i);

if(DOWN(e))e->head->l= i;
else e->tail->r= i;
edges[i].level= e->head->level;
edges[i].v= e->head;
}
t->root->l= 0;t->root->r= t->m-1;
range_preprocess(edges,t->m,sizeof(struct lca_elt),lca_query,PR3 lca_upd);
return lca_query;
}

/*:37*//*38:*/
#line 1152 "trees.web"

async TREE_NODE*lca(pr TREE_NODE*u,pr TREE_NODE*v,pr RANGE*lcaquery)
{
pr int i;
pr struct lca_elt answer;

if(u->l<v->l&&v->r<u->r)return u;
if(v->l<u->l&&u->r<v->r)return v;

range_query(u->r,v->l,lcaquery,&answer,PR3 lca_upd);

return answer.v;
}

/*:38*//*40:*/
#line 1226 "trees.web"

sync void bin_conrec(sh TREE*t,sh TREE_NODE**leaves,sh int n,
sh TREE_NODE*first,sh TREE_NODE*last,
async void(*rk)(void*,void*,void*),
async void(*rkrt)(void*,void*,void*),
async void(*unrk)(void*,void*,void*))
{
sh int p= groupsize();
sh TREE_NODE**remleaves;
pr TREE_NODE*u,*sib,*par;
pr int i;

if(n>0){
seq remleaves= leaves+n;

farm{
ppar_array(i,(n+1)>>1){
u= leaves[i<<1];
if(u->child_no==0)/*41:*/
#line 1314 "trees.web"

{
par= u->parent;
sib= par->children[1-u->child_no];
#ifdef TESTING
pprintf("rake %d %d %d\n",NODE_NO(u,t),NODE_NO(par,t),NODE_NO(sib,t));
#endif
rk(u->content,par->content,sib->content);
sib->parent= par->parent;
sib->child_no= par->child_no;
sib->parent->children[sib->child_no]= sib;
}

/*:41*/
#line 1244 "trees.web"

remleaves[i]= leaves[(i<<1)+1];
}
}

farm{
ppar_array(i,(n+1)>>1){
u= leaves[i<<1];
if(u->child_no==1)/*41:*/
#line 1314 "trees.web"

{
par= u->parent;
sib= par->children[1-u->child_no];
#ifdef TESTING
pprintf("rake %d %d %d\n",NODE_NO(u,t),NODE_NO(par,t),NODE_NO(sib,t));
#endif
rk(u->content,par->content,sib->content);
sib->parent= par->parent;
sib->child_no= par->child_no;
sib->parent->children[sib->child_no]= sib;
}

/*:41*/
#line 1252 "trees.web"

}
}

bin_conrec(t,remleaves,n>>1,first,last,rk,rkrt,unrk);

farm{
ppar_array(i,(n+1)>>1){
u= leaves[i<<1];
if(u->child_no==1)/*42:*/
#line 1329 "trees.web"

{
par= u->parent;sib= par->children[1-u->child_no];
#ifdef TESTING
pprintf("unrake %d %d %d\n",NODE_NO(u,t),NODE_NO(par,t),NODE_NO(sib,t));
#endif
par->parent->children[par->child_no]= par;
sib->parent= par;
sib->child_no= 1-u->child_no;
unrk(u->content,par->content,sib->content);
}

/*:42*/
#line 1261 "trees.web"

}
}
farm{
ppar_array(i,(n+1)>>1){
u= leaves[i<<1];
if(u->child_no==0)/*42:*/
#line 1329 "trees.web"

{
par= u->parent;sib= par->children[1-u->child_no];
#ifdef TESTING
pprintf("unrake %d %d %d\n",NODE_NO(u,t),NODE_NO(par,t),NODE_NO(sib,t));
#endif
par->parent->children[par->child_no]= par;
sib->parent= par;
sib->child_no= 1-u->child_no;
unrk(u->content,par->content,sib->content);
}

/*:42*/
#line 1267 "trees.web"

}
}
}else{
farm rkrt(first->content,first->parent->content,last->content);
}
}


sync void bintree_contract(sh TREE*t,sh LIST*eulerlist,
async void(*rk)(void*,void*,void*),
async void(*rkrt)(void*,void*,void*),
async void(*unrk)(void*,void*,void*))
{
sh int p= groupsize();
sh TREE_NODE**leaves;
sh int*index;

pr int i;
pr TREE_EDGE*e;

index= (int*)shalloc(t->m*sizeof(int));
leaves= (TREE_NODE**)shalloc(t->n*sizeof(TREE_NODE*));


farm
ppar_array(i,t->m){
e= (TREE_EDGE*)ELT(eulerlist,i);
if(LEAF(e->head))index[i]= 1;else index[i]= 0;
}
prefix_add(index,t->m,index,-1);
farm
ppar_array(i,t->m){
e= (TREE_EDGE*)ELT(eulerlist,i);
if(LEAF(e->head))leaves[index[i]]= e->head;
}

bin_conrec(t,leaves+1,index[t->m-1]-1,leaves[0],leaves[index[t->m-1]],
rk,rkrt,unrk);
shallfree();
}

/*:40*//*43:*/
#line 1358 "trees.web"

struct binheight{
int topdiff;
int halfheight;
int height;
};

async void height_init(pr struct binheight*node)
{
node->topdiff= 0;
node->halfheight= 0;
node->height= 0;
}


async void height_in(pr struct binheight*leaf,pr struct binheight*par,
pr struct binheight*sib)
{
int h;

par->height= sib->topdiff;
sib->topdiff= sib->topdiff+1+par->topdiff;

h= 1+max(leaf->halfheight,sib->halfheight);
sib->halfheight= max(par->topdiff+h,par->halfheight);
par->halfheight= h;
}


async void height_out(pr struct binheight*leaf,pr struct binheight*par,
pr struct binheight*sib)
{
par->height= max(par->halfheight,1+par->height+sib->height);
}


async void height_root(pr struct binheight*leaf,pr struct binheight*par,
pr struct binheight*sib)
{
par->height= 1+max(leaf->halfheight,sib->halfheight);
}

sync void bintree_height(sh TREE*t,sh LIST*eulerlist)
{
pr TREE_NODE*v;

par_nodes(v,t){

v->content= (struct binheight*)malloc(sizeof(struct binheight));
height_init(v->content);
}
bintree_contract(t,eulerlist,PR3 height_in,PR3 height_root,PR3 height_out);
par_nodes(v,t)v->height= ((struct binheight*)v->content)->height;
}

/*:43*//*44:*/
#line 1425 "trees.web"

sync void tree_height(sh TREE*t,sh LIST eulerlist[])
{
sh int p= groupsize();
sh RANGE depthquery;
sh int*levels;
pr int i;
pr TREE_NODE*v;

range_alloc(t->m,sizeof(int),&depthquery);
levels= (int*)depthquery.pre[0];
ppar_array(i,t->m)
levels[i]= ((TREE_EDGE*)ELT(eulerlist,i))->head->level;

range_preprocess(levels,t->m,sizeof(int),&depthquery,PR3 _amaxup);
par_nodes(v,t){
range_query(v->l,v->r,&depthquery,&v->height,PR3 _amaxup);
v->height= v->height-v->level;
}
}

/*:44*//*45:*/
#line 1458 "trees.web"

sync TREE*complete_tree(sh int n,sh int degree,sh int children)
{
sh int p= groupsize();

sh TREE*t;
sh int nn;
pr int i,j,k,l;

seq{
nn= (n-1)/degree;
n= nn*degree+1;
}
t= tree_alloc(n);

ppar_array(i,nn){
t->nodes[i].node_id= ME;
t->nodes[i].degree= degree+1;
t->nodes[i].firstedge= t->edges+(i*(degree+1)-1);
}
ppar_arrayseg(i,nn,n-nn){
t->nodes[i].node_id= ME;
t->nodes[i].degree= 1;
t->nodes[i].firstedge= t->edges+(nn*degree-1+i);
}
seq{
t->nodes[0].node_id= 0;
t->nodes[0].degree= degree;
t->nodes[0].firstedge= t->edges;
}

ppar_array(i,nn){


for(j= 0;j<children;j++){
k= i*children+1+j;
l= t->nodes[k].degree-1;

t->nodes[i].firstedge[j].edge_id= ME;
t->nodes[i].firstedge[j].tail= t->nodes+i;
t->nodes[i].firstedge[j].head= t->nodes+k;
t->nodes[i].firstedge[j].rev= t->nodes[k].firstedge+l;

t->nodes[k].firstedge[l].edge_id= ME;
t->nodes[k].firstedge[l].tail= t->nodes+k;
t->nodes[k].firstedge[l].head= t->nodes+i;
t->nodes[k].firstedge[l].rev= t->nodes[i].firstedge+j;
}



for(;j<degree;j++){
k= nn*children+1+i*(degree-children)+j-children;

t->nodes[i].firstedge[j].edge_id= ME;
t->nodes[i].firstedge[j].tail= t->nodes+i;
t->nodes[i].firstedge[j].head= t->nodes+k;
t->nodes[i].firstedge[j].rev= t->nodes[k].firstedge;

t->nodes[k].firstedge[0].edge_id= ME;
t->nodes[k].firstedge[0].tail= t->nodes+k;
t->nodes[k].firstedge[0].head= t->nodes+i;
t->nodes[k].firstedge[0].rev= t->nodes[i].firstedge+j;
}
}

return t;
}

/*:45*/
